using System;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Vha.Vss.Utility;
using Vha.Vtk.Kernel.Common;
using System.Xml;
using System.Xml.XPath;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;

namespace VTK.Administration
{
	/// <summary>
	/// Summary description for Configuration.
	/// </summary>
	public class Configuration : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtName;
		protected System.Web.UI.WebControls.TextBox txtVersion;
		protected System.Web.UI.WebControls.TextBox txtSecurityPolicy;
		protected System.Web.UI.WebControls.TextBox txtConnectionString;
		protected System.Web.UI.WebControls.TextBox txtDSNName;
		protected System.Web.UI.WebControls.TextBox txtDSNUserName;
		protected System.Web.UI.WebControls.TextBox txtPassword;
		protected System.Web.UI.WebControls.TextBox txtDSNDatabase;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.RadioButtonList AppRadioButton;
		protected System.Web.UI.WebControls.Label lblTitle;
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.TextBox AppPathText;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.TextBox TimeOutText;
		protected System.Web.UI.WebControls.Label App_TimeoutLabel;
	
		protected Vha.Vss.Utility.AppConfiguration VssConfig;
		protected ReturnStatus ret;
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (VtkPageHeader1.IsDivSelected("Web Configuration")) 
			{
				ret = new ReturnStatus();
				if(!Page.IsPostBack)
				{
					//if none select, select Vtk.  AppRadioButton: 0=Vtk, 1=VtkUser
					if (AppRadioButton.SelectedIndex < 0)
					{
						AppRadioButton.SelectedIndex = 0 ;
						SetApp(false) ;
					}
				}
				//save the stationId on the form
				Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
			}
			else
			{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
		}

		private string MissingFields(bool IsVtkUser)
		{
			bool flag = false ;
			string fields = string.Empty ;
			if (txtName.Text == string.Empty)
			{
				fields = "Name" ;
				flag = true ;
			}
			if (txtVersion.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Version" ;
			}
			if (txtSecurityPolicy.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Security Policy" ;
			}
			if (!IsVtkUser && (AppPathText.Text == string.Empty))
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Application Path" ;
			}
			if (IsVtkUser && (TimeOutText.Text == string.Empty))
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "TimeOut" ;
			}
			if (txtDSNName.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "DSN Name" ;
			}
			if (txtDSNDatabase.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Database" ;
			}
			if (txtDSNUserName.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "User Name" ;
			}
			if (txtPassword.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Password" ;
			}
			if (txtConnectionString.Text == string.Empty)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Connection String" ;
			}

			return fields ;
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			DataEncoder dataEncoder = new DataEncoder("VhaVss");
			//AppRadioButton: 0=Vtk, 1=VtkUser
			bool IsVtkUser = Convert.ToBoolean(AppRadioButton.SelectedIndex) ;
			string missingdata = MissingFields(IsVtkUser) ;
			if (missingdata != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following field(s) are Missing Data: " + missingdata) ;}
			else
			{
				try
				{
					VssConfig = SetAppConfig(IsVtkUser) ;
					if (VssConfig != null)
					{

						VssConfig.SetAppConfigData(ViewState["ApplicationName"].ToString(), "Version", txtVersion.Text);
						VssConfig.SetAppConfigData(ViewState["ApplicationName"].ToString(), "Security", txtSecurityPolicy.Text);
						VssConfig.SetAppConfigData(ViewState["ApplicationName"].ToString(), "Name", txtName.Text);
						//if Vtk, then set path
						if (!IsVtkUser)
						{
							VssConfig.SetAppConfigData(ViewState["ApplicationName"].ToString(), "Path", AppPathText.Text);
							ViewState["Path"] = AppPathText.Text ;
						}
						else
						{
							//VtkUser stores timeout
							VssConfig.SetAppConfigData(ViewState["ApplicationName"].ToString(), "TimeOut", TimeOutText.Text);
						}				
						
						try
						{
							SqlConnection sqlConnection = new SqlConnection(txtConnectionString.Text);
							sqlConnection.Open();
							if(sqlConnection.State == ConnectionState.Open)
							{
								VssConfig.SetDBConfigData("VssConfiguration", ViewState["DBConnectionName"].ToString(), "ConnectionString", ApplicationConnection.EncryptPassword(txtConnectionString.Text));
								sqlConnection.Close();
								sqlConnection.Dispose();
							}
						}
						catch(SqlException SqlEx)
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error opening the SqlConnection with the provided connection string: " + SqlEx.Message);
							return;
						}

						VssConfig.SetDSNConfigData("VssConfiguration", ViewState["DSNName"].ToString(), "Name", txtDSNName.Text);
						ViewState["DSNName"] = txtDSNName.Text;

						VssConfig.SetDSNConfigData("VssConfiguration", ViewState["DSNName"].ToString(), "Password", "[" + dataEncoder.EncodeString(txtPassword.Text) + "]");
						VssConfig.SetDSNConfigData("VssConfiguration", ViewState["DSNName"].ToString(), "DBName", txtDSNDatabase.Text);
						
						VssConfig.Save();
						//update confirmation message
						ConfirmationMessage.Text = "Record Saved!" ;
					}
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error saving Web Configuration: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error saving Web Configuration: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error saving Web Configuration: " + err.Message) ;}
			}
		}

		private void AppRadioButton_Click(object sender, System.EventArgs e)
		{
			//AppRadioButton: 0=Vtk, 1=VtkUser
			SetApp((AppRadioButton.SelectedIndex == 1)) ;		
		}

		private void SetApp(bool IsVtkUser)
		{
			string Password ;
			string DBConnection ;
			string Path ;
			DataEncoder dataDecoder = new DataEncoder("VhaVss");

			try
			{
				VssConfig = SetAppConfig(IsVtkUser) ;
				if (VssConfig != null)
				{
					XmlNode DSNNode = VssConfig.GetDSNConfigData("", String.Empty);
					XmlNode ApplicationNode = VssConfig.GetAppConfigData("", String.Empty);
					XmlNode DBConnectionNode = VssConfig.GetDBConfigData("", String.Empty);

					ViewState["ApplicationName"] = ApplicationNode.Attributes.GetNamedItem("Name").Value;
					ViewState["DBConnectionName"] = DBConnectionNode.Attributes.GetNamedItem("Name").Value;
					ViewState["DSNName"] = DSNNode.Attributes.GetNamedItem("Name").Value;
					//if Vtk, then set ViewState and text field to path
					if (!IsVtkUser)
					{
						Path = ApplicationNode.Attributes.GetNamedItem("Path").Value ;
						ViewState["Path"] = Path ;
						AppPathText.Text = Path ;
						AppPathText.Visible = true ;
						TimeOutText.Visible = false ;
						App_TimeoutLabel.Text = "Application Path:" ;
					}
					else
					{
						//VtkUser has no path
						//VtkUser timeout is stored in Path.
						Path = ApplicationNode.Attributes.GetNamedItem("TimeOut").Value ;
						App_TimeoutLabel.Text = "TimeOut:" ;
						TimeOutText.Text = Path ;
						AppPathText.Visible = false ;
						TimeOutText.Visible = true ;
					}

					txtName.Text = ApplicationNode.Attributes.GetNamedItem("Name").Value;
					txtVersion.Text = ApplicationNode.Attributes.GetNamedItem("Version").Value;
					txtSecurityPolicy.Text = ApplicationNode.Attributes.GetNamedItem("Security").Value;
					
					DBConnection = DBConnectionNode.Attributes.GetNamedItem("ConnectionString").Value;
					if(DBConnection.IndexOf("[") != -1 && DBConnection.IndexOf("]") != -1)
						txtConnectionString.Text = ApplicationConnection.DecryptPassword(DBConnection);
					else
						txtConnectionString.Text = DBConnection;

					txtDSNName.Text = DSNNode.Attributes.GetNamedItem("Name").Value;
					txtDSNDatabase.Text = DSNNode.Attributes.GetNamedItem("DBName").Value;
					txtDSNUserName.Text = DSNNode.Attributes.GetNamedItem("UserId").Value;
					Password = DSNNode.Attributes.GetNamedItem("Password").Value;

					if(Password.StartsWith("[") && Password.EndsWith("]"))
					{
						txtPassword.Text = dataDecoder.DecodeString(Password.Substring(1, Password.Length-2));
					}
					else
					{
						txtPassword.Text = Password;
					}
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Web Configuration: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Web Configuration: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Web Configuration: " + err.Message) ;}
		}

		private AppConfiguration SetAppConfig(bool IsVtkUser)
		{
			VssConfig = null ;
			string path = string.Empty ;

			//edit VtkUser, check for path
			if (IsVtkUser)
			{
				if (ViewState["Path"].ToString() == string.Empty)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "Cannot continue with VtkUser application without an 'Application Path' in Vtk") ;}
				else
				{
					try
					{
						//this is VtkUser, try path
						path = ViewState["Path"].ToString() + @"\VtkUser\web.config" ;
						VssConfig = new AppConfiguration(path);
						VssConfig.Load();
					}
					catch(Exception err)
					{
						VssConfig = null ;
						VtkUtility.ErrMsgAdd(ErrorMessage, "Error: "  + err.Message) ;
					}
				}
			}
			else
			{
				//Vtk
				VssConfig = new AppConfiguration(Server.MapPath("..") + @"\web.config");
				VssConfig.Load();
			}
			//check if we can proceed
			if (VssConfig == null)
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, "Cannot continue with VtkUser application, incorrect Path. Please exit and try again") ;
				VssConfig = null ;
				PostButton.Enabled = false ;
			}

			return VssConfig ;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.AppRadioButton.SelectedIndexChanged += new System.EventHandler(this.AppRadioButton_Click);
			this.PostButton.Click += new System.EventHandler(this.btnSave_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


	}
}
