using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;

using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using Vha.Vtk.Donations;
using System.Globalization;

namespace VTK.FileMaintenance
{
	/// <summary>
	/// Summary description for DonationEdit.
	/// </summary>
	public class DonationEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.ValidationSummary ValidationSummary1;
		protected System.Web.UI.WebControls.DropDownList DonorTypeList;
		protected System.Web.UI.WebControls.Label DonorTypeLabel;
		protected System.Web.UI.WebControls.Panel IndividualPanel;
		protected System.Web.UI.WebControls.TextBox NamePrefixText;
		protected System.Web.UI.WebControls.TextBox LastNameText;
		protected System.Web.UI.WebControls.TextBox FirstNameText;
		protected System.Web.UI.WebControls.TextBox MiddleNameText;
		protected System.Web.UI.WebControls.TextBox SuffixText;
		protected System.Web.UI.WebControls.TextBox PUCText;
		protected System.Web.UI.WebControls.DropDownList OrganizationList;
		protected System.Web.UI.WebControls.Label OrganizationLabel;
		protected System.Web.UI.WebControls.TextBox Address2Text;
		protected System.Web.UI.WebControls.TextBox Address1Text;
		protected System.Web.UI.WebControls.DropDownList StateList;
		protected System.Web.UI.WebControls.TextBox ZipText;
		protected System.Web.UI.WebControls.TextBox CityText;
		protected System.Web.UI.WebControls.TextBox AffiliationText;
		protected System.Web.UI.WebControls.DropDownList DonationTypeList;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate DonationDate;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate CheckDate;
		protected System.Web.UI.WebControls.Label CheckDateLabel;
		protected System.Web.UI.WebControls.TextBox CheckNumberText;
		protected System.Web.UI.WebControls.Label CheckLabel;
		protected System.Web.UI.WebControls.Label GPFLabel;
		protected System.Web.UI.WebControls.TextBox FSRText;
		protected System.Web.UI.WebControls.Label FSRLabel;
		protected System.Web.UI.WebControls.TextBox DescriptionText;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate AcknowledgementDate;
		protected System.Web.UI.WebControls.TextBox DesignationText;
		protected System.Web.UI.WebControls.TextBox FamilyContactText;
		protected System.Web.UI.WebControls.TextBox InMemoryText;
		protected System.Web.UI.WebControls.TextBox SalutationText;
		protected System.Web.UI.WebControls.TextBox CCField1;
		protected System.Web.UI.WebControls.TextBox CCField2;
		protected System.Web.UI.WebControls.TextBox CCField3;
		protected System.Web.UI.WebControls.TextBox CCField4;
		protected System.Web.UI.WebControls.TextBox CCField5;
		//protected System.Web.UI.WebControls.TextBox GPFText1;
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.Button DeleteButton;
		protected System.Web.UI.WebControls.Button PrintButton;
		protected System.Web.UI.WebControls.Label StarCheckNumberLabel;
		protected System.Web.UI.WebControls.Label StarGPFLabel;
		protected System.Web.UI.WebControls.DropDownList ReferenceList;
		protected System.Web.UI.WebControls.Label InMemLabel;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Label ValueLabel;
		protected System.Web.UI.WebControls.Label LocalBranchLabel;
		protected System.Web.UI.WebControls.DataGrid GPFGrid;
		protected System.Web.UI.WebControls.Label StarOrgGrpLabel;
		protected DataSet dsdndtl;

		private bool bIsActivityItem ;

	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Add|Edit Donation"))
				{
					if (!Page.IsPostBack)
					{
						//check for input parameter, must have or error
						if (Page.Request.QueryString["donationId"] == null)
						{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations, Please Exit and try again") ;}
						else
						{
							string donorName = string.Empty ;
							int donorType = 0 ;

							//save in view state
							ViewState["donationId"] = Page.Request.QueryString["donationId"].ToString() ;
							if (ViewState["donationId"].ToString() == "new")
							{
								ViewState["donorId"] = Page.Request.QueryString["donorId"].ToString() ;
								ViewState["donorName"] = Page.Request.QueryString["donorName"].ToString() ;
							}
							//populate all lists
							GetLists() ;
							//initializes date fields
							CheckDate.YearListBegin = (DateTime.Now.Year-1) ;
							CheckDate.YearListEnd = DateTime.Now.Year ;
							CheckDate.InitializeControl() ;
							DonationDate.YearListBegin = (DateTime.Now.Year-1) ;
							DonationDate.YearListEnd = DateTime.Now.Year ;
							DonationDate.InitializeControl() ;
							//initializat date to today
							DonationDate.Date = DateTime.Today ;
							AcknowledgementDate.YearListBegin = DateTime.Now.Year ;
							AcknowledgementDate.YearListEnd = DateTime.Now.Year ;
							AcknowledgementDate.InitializeControl() ;

							//enable postbutton
							PostButton.Enabled = true ;

							//check if donations of donor is new, if not then get record
							if (ViewState["donationId"].ToString() == "new")
							{
								//new donation, default to today
								ViewState["donationId"] = string.Empty ;
								PopulateDonationDetails(0);
							}
							else
							{ GetDonation(ViewState["donationId"].ToString()) ;}
							//new donor, populate last name field or Affiliation or Organization
							if (ViewState["donorId"].ToString() == "new")
							{
								if (ViewState["donorName"].ToString() != string.Empty)
								{
									//donorName begins with (1=individual,4=organization,5=affiliation)
									donorName = ViewState["donorName"].ToString() ;
									donorType = Convert.ToInt32(donorName.Substring(0,1)) ;
									switch (donorType)
									{
										case 1:
											LastNameText.Text = donorName.Substring(1,donorName.Length-1) ;
											break ;
										case 4:
											VtkUtility.SetSelectedSingle(OrganizationList.Items, donorName.Substring(1,donorName.Length-1)) ;
											break ;
										case 5:
											AffiliationText.Text = donorName.Substring(1,donorName.Length-1) ;
											break ;
									}
									//update DonorTypeList and ViewState, enable proper fields
									VtkUtility.SetSelectedSingle(DonorTypeList.Items, donorType.ToString()) ;
									DonorType(donorType.ToString()) ;
									ViewState["donorName"] = null ;
								}
								ViewState["donorId"] = string.Empty ;
							}
							else
							{ GetDonor(ViewState["donorId"].ToString()) ;}
						}
					}

					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donations: " + err.Message) ;}
		}

		private void GetDonation(string donation)
		{
			try
			{
				int donationId ;
				string donationType ;
				string referenceFK;
				Vha.Vtk.Donations.Donation donatHdl ;
				if (donation != string.Empty)
				{

					donationId = Convert.ToInt32(donation) ;
					donatHdl = new Vha.Vtk.Donations.Donation(donationId, VtkUtility.GetAppCon()) ;
					//save version and donorId in viewstate
					ViewState["donatVersion"] = donatHdl.Version.ToString() ;
					ViewState["donorId"] = donatHdl.DonorId.ToString() ;
					//get field values
					DonationDate.Date = donatHdl.DonationDate.Date ;
					//ValueText.Text = donatHdl.DonationValue.ToString() ;
					//GPFText1.Text = donatHdl.GeneralPostFund ;
					CheckNumberText.Text = donatHdl.CheckNumber ;
					CheckDate.Date = donatHdl.CheckDate.Date ;
					FSRText.Text = donatHdl.FieldServiceReceipt ;
					DescriptionText.Text = donatHdl.DonationDescription ;
					DesignationText.Text = donatHdl.Designation ;
					InMemoryText.Text = donatHdl.InMemoryOf ;
					SalutationText.Text = donatHdl.Salutation ;
					PUCText.Text = donatHdl.Post_Unit_Chapter ;
					AcknowledgementDate.Date = donatHdl.AcknowledgementDate.Date ;
					donationType = donatHdl.DonationTypeId.ToString() ;
					referenceFK = donatHdl.DonationReferenceFK.ToString() ;
					CCField1.Text = donatHdl.CC1;
					CCField2.Text = donatHdl.CC2;
					CCField3.Text = donatHdl.CC3;
					CCField4.Text = donatHdl.CC4;
					CCField5.Text = donatHdl.CC5;
					FamilyContactText.Text = donatHdl.FamilyContact;
					//ReferenceList.s = donatHdl.DonationReferenceFK ;

					//set list values
					VtkUtility.SetSelectedSingle(DonationTypeList.Items, donationType) ;

					//set list values
					VtkUtility.SetSelectedSingle(ReferenceList.Items, referenceFK) ;

					//enable delete button
					DeleteButton.Enabled = true ;
					PrintButton.Enabled = true ;
					DonationType(donationType) ;

					PopulateDonationDetails(donationId);
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation Record: " + err.Message) ;}
		}

		private void PopulateDonationDetails(Int32 DonId)
		{
			try
			{
				//populate Donation Details, get dataset
				dsdndtl = Vha.Vtk.Donations.Donation.GetQuickListDonationDetailsBy_DonationId(DonId) ;
				DataTable dtdndtl = dsdndtl.Tables["DonationDetails"] ;
				//bIsActivityItem = Convert.ToBoolean(ViewState["IsActivityItem"].ToString());
				//add the new row only if it is Activity or Item donation
				if (bIsActivityItem != true || DonId == 0)
				{
					//add the first row
					DataRow drdtl = dtdndtl.NewRow() ;
					drdtl["DonationSummaryFK"] = DonId.ToString() ;
					drdtl["GeneralPostFundFK"] = 0 ;
					drdtl["GeneralPostFund"] = "" ;
					drdtl["DonationValue"] = 0 ;
					drdtl["Status"] = "" ;
					//dtdndtl.Rows.InsertAt(drdtl, 0) ;
					dtdndtl.Rows.Add(drdtl);
				}

				//save the ViewState
				System.IO.StringWriter sw = new System.IO.StringWriter();
				dsdndtl.WriteXml(sw, System.Data.XmlWriteMode.IgnoreSchema);
				ViewState["dsdndtl"] = sw.ToString();

				GPFGrid.DataSource = dtdndtl;
				GPFGrid.DataBind() ;
				SetDDList();
				dsdndtl.Dispose() ;
				dtdndtl.Dispose() ;

	/*				foreach(DataGridItem dgItm in GPFGrid)
					{
						//DropDownList ddlist = (DropDownList).Cells[2].FindControl("GPFText") ;
						DropDownList ddlist = (DropDownList)dgItm.Cells[2].FindControl("GPFList");
						ddlist.DataSource;
					} */

	/*				DataRowView drv = (DataRowView) e.Item.DataItem;
					String currentgenre = drv["genre"].ToString();
					DropDownList ddl = 
						(DropDownList) e.Item.FindControl("DropDownList1");
					ddl.SelectedIndex = 
						ddl.Items.IndexOf(ddl.Items.FindByText(currentgenre));*/

			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation details: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation details: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donation details: " + err.Message) ;}
		}

		private void SetDDList()
		{
			System.Decimal dValue = 0;
			foreach( DataGridItem di in GPFGrid.Items )
			{
				DropDownList ddList = (DropDownList)di.FindControl("GPFList") ;
				//DataRowView drv = (DataRowView) di.DataItem;
				String currentGPF = di.Cells[1].Text ;
				if (currentGPF == "&nbsp;" || currentGPF == "" )
				{	
					currentGPF="";
				}
				// = drv["GeneralPostFund"].ToString();

				if (bIsActivityItem)
				{
					ddList.Enabled=false;
					currentGPF="None";
				}
				else
				{
					ddList.Enabled=true;
				}

				ddList.SelectedIndex = ddList.Items.IndexOf(ddList.Items.FindByValue(currentGPF));

				TextBox ValueText = (TextBox)di.FindControl("DonationValueText") ;
				if (ValueText.Text != "")
				{dValue = System.Decimal.Add(dValue, Convert.ToDecimal(ValueText.Text));}
			
			}
			ValueLabel.Text = "$"+dValue.ToString();

		}
		private void GetDonor(string donor)
		{
			try
			{
				int donorId ;
				int donorType ;
				Vha.Vtk.Donations.Donor donorHdl ;
				if (donor != string.Empty)
				{
					donorId = Convert.ToInt32(donor) ;
					donorHdl = new Vha.Vtk.Donations.Donor(donorId, VtkUtility.GetAppCon()) ;
					//save version and donorId in viewstate
					ViewState["donorVersion"] = donorHdl.Version.ToString() ;
					//populate fields
					LastNameText.Text = donorHdl.LastName ;
					FirstNameText.Text = donorHdl.FirstName ;
					MiddleNameText.Text = donorHdl.MiddleName ;
					SuffixText.Text = donorHdl.NameSuffix ;
					NamePrefixText.Text = donorHdl.NamePrefix ;
					Address1Text.Text = donorHdl.Address1 ;
					Address2Text.Text = donorHdl.Address2 ;
					CityText.Text = donorHdl.City ;
					ZipText.Text = donorHdl.Zip ;
					AffiliationText.Text = donorHdl.DonorAffiliation ;
					//set donor type, make uneditable
					donorType = donorHdl.DonorTypeId ;
					VtkUtility.SetSelectedSingle(DonorTypeList.Items, donorType.ToString()) ;
					DonorTypeLabel.Text = DonorTypeList.SelectedItem.Text ;
					DonorTypeLabel.Visible = true ;
					DonorTypeList.Visible = false ;
					//display correct fields
					DonorType(donorType.ToString()) ;

					//set list values
					VtkUtility.SetSelectedSingle(StateList.Items, donorHdl.StateId.ToString()) ;
					VtkUtility.SetSelectedSingle(OrganizationList.Items, donorHdl.OrganizationId.ToString()) ;
					ViewState["donorName"] = DonorName(donorType.ToString()) ;
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donor Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donor Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Donor Record: " + err.Message) ;}
		}
		public DataTable GetDonationGPF()
		{
			//DataTextField='<%# DataBinder.Eval(Container.DataItem, "GeneralPostFundFK") %>' 
			//siteId is needed for organization list
			int siteId = VtkPageHeader1.DivSelectedId ;
			//populate list of GPF accounts,

			DataSet dsgpf = Donation.GetQuickListGPFsBy_StationId(siteId) ;
			DataTable dtgpf = dsgpf.Tables["GetQuickListGPFsBy_StationId"] ;

			/* DataRow drgpf = dtgpf.NewRow() ;
			drgpf["ID"] = 0;
			drgpf["GeneralPostFund"] = " -- Select GPF Account --";
			dtgpf.Rows.InsertAt(drgpf,0); */

			return dtgpf;
		}
		private void GetLists()
		{
			//siteId is needed for organization list
			int siteId = VtkPageHeader1.DivSelectedId ;

			//populate Donor Type list
			DataSet dtds = Vha.Vtk.Donations.DonorType.GetQuickList() ;
			DataTable dtdt = dtds.Tables["DonorTypeList"] ;

			DonorTypeList.DataTextField = "DonorType" ;
			DonorTypeList.DataValueField = "Id" ;
			DonorTypeList.DataSource = dtdt ;
			DonorTypeList.DataBind() ;
			dtds.Dispose() ;
			dtdt.Dispose() ;

			//populate Donation Type list
			DataSet dntds = Vha.Vtk.Donations.DonationType.GetQuickList() ;
			DataTable dntdt = dntds.Tables["DonationTypeList"] ;

			DonationTypeList.DataTextField = "DonationType" ;
			DonationTypeList.DataValueField = "Id" ;
			DonationTypeList.DataSource = dntdt ;
			DonationTypeList.DataBind() ;
			//set default to check
			VtkUtility.SetSelectedSingle(DonationTypeList.Items, "2") ;
			DonationType("2") ;
			dntds.Dispose() ;
			dntdt.Dispose() ;

			//populate list of Organizations, get dataset, sort by code
			//ref. Vha.Vtk.Common.Organization
			DataSet dsorg = Organization.GetSiteActiveQuickListByName(siteId) ;
			DataTable dtorg = dsorg.Tables["OrganizationList"] ;

			//add the first row
			DataRow drorg = dtorg.NewRow() ;
			drorg["DisplayName"] = " -Select Organization Code- " ;
			drorg["Id"] = 0 ;
			dtorg.Rows.InsertAt(drorg, 0) ;
				
			//define columns in list box
			OrganizationList.DataTextField = "DisplayName" ;
			OrganizationList.DataValueField = "Id" ;
			OrganizationList.DataSource = dtorg ;
			OrganizationList.DataBind() ;
			dsorg.Dispose() ;
			dtorg.Dispose() ;
						
			//populate list of References, get dataset, sort by Reference
			//ref. Vha.Vtk.Donations.Donation
			DataSet dsref = Donation.GetQuickListReferencesBy_StationId(siteId) ;
			DataTable dtref = dsref.Tables["GetQuickListReferencesBy_StationId"] ;

			//add the first row
			//DataRow drref = dtref.NewRow() ;
			//drref["DonationReference"] = " - None - " ;
			//drref["Id"] = 0 ;
			//dtref.Rows.InsertAt(drref, 0) ;
				
			//define columns in list box
			ReferenceList.DataTextField = "DonationReference" ;
			ReferenceList.DataValueField = "Id" ;
			ReferenceList.DataSource = dtref ;
			ReferenceList.DataBind() ;
			dsref.Dispose() ;
			dtref.Dispose() ;

			//populate state list
			DataSet dsst = Vha.Vtk.Kernel.Data.SystemTables.State.GetQuickList() ;
			DataTable dtst = dsst.Tables["StateList"] ;
			dtst.DefaultView.Sort = "Abbreviation ASC" ;

			// insert a new row for the "not selected" item
			DataRow stdr = dtst.NewRow() ;
			stdr["Id"]=int.MinValue;
			stdr["Abbreviation"]="--";
			dtst.Rows.InsertAt(stdr,0);

			StateList.DataTextField = "Abbreviation" ;
			StateList.DataValueField = "Id" ;
			StateList.DataSource = dtst.DefaultView ;
			StateList.DataBind() ;
			dsst.Dispose() ;
			dtst.Dispose() ;

		}

		private void DonorType(string type)
		{
			switch (type)
			{
				case "1":
					//individual
					IndividualPanel.Visible = true ;
					OrganizationLabel.Visible = false ;
					StarOrgGrpLabel.Visible = false ;
					OrganizationList.Visible = false ;
					//AffiliationLabel.Visible = false ;
					AffiliationText.Visible = false ;
					//StarAffLabel.Visible = false;
					LocalBranchLabel.Visible = false;
					PUCText.Visible = false;
					PUCText.Text = "";
					OrganizationList.SelectedIndex = 0;
					AffiliationText.Text = "";
					break ;
				case "2":
					//individual & organization
					IndividualPanel.Visible = true ;
					OrganizationLabel.Visible = true ;
					OrganizationList.Visible = true ;
					StarOrgGrpLabel.Visible = true ;
					OrganizationLabel.Text = "Organization:";
					//AffiliationLabel.Visible = false ;
					AffiliationText.Visible = false ;
					//StarAffLabel.Visible = false;
					LocalBranchLabel.Visible = true;
					PUCText.Visible = true;
					AffiliationText.Text = "";
					break ;
				case "3":
					//individual & affiliation
					IndividualPanel.Visible = true ;
					OrganizationList.Visible = false ;
					StarOrgGrpLabel.Visible = true ;
					OrganizationLabel.Visible = true ;
					OrganizationLabel.Text = "Other Groups:";
					//AffiliationLabel.Visible = true ;
					AffiliationText.Visible = true ;
					//StarAffLabel.Visible = true;
					OrganizationList.SelectedIndex = 0;
					LocalBranchLabel.Visible = true;
					PUCText.Visible = true;
					PUCText.Text = "";
					break ;
				case "4":
					//organization
					IndividualPanel.Visible = false ;
					OrganizationLabel.Visible = true ;
					OrganizationList.Visible = true ;
					OrganizationLabel.Text = "Organization:";
					StarOrgGrpLabel.Visible = true ;
					//AffiliationLabel.Visible = false ;
					AffiliationText.Visible = false ;
					//StarAffLabel.Visible = false;
					LocalBranchLabel.Visible = true;
					PUCText.Visible = true;
					NamePrefixText.Text= "";
					LastNameText.Text= "";
					FirstNameText.Text= "";
					MiddleNameText.Text= "";
					SuffixText.Text= "";
					AffiliationText.Text = "";
					break ;
				case "5":
					//affiliation
					IndividualPanel.Visible = false ;
					OrganizationLabel.Visible = true ;
					OrganizationList.Visible = false ;
					StarOrgGrpLabel.Visible = true ;
					OrganizationLabel.Text = "Other Groups:";
					//AffiliationLabel.Visible = true ;
					AffiliationText.Visible = true ;
					//StarAffLabel.Visible = true;
					OrganizationList.SelectedIndex = 0;
					LocalBranchLabel.Visible = true;
					PUCText.Visible = true;
					NamePrefixText.Text= "";
					LastNameText.Text= "";
					FirstNameText.Text= "";
					MiddleNameText.Text= "";
					SuffixText.Text= "";
					PUCText.Text = "";
					break ;
			}
		}

		private string DonorName(string type)
		{
			string displayName = LastNameText.Text + ", " + FirstNameText.Text ;
			//Donor Type: 1=Individual, 2=Ind&Org, 3=Ind&Affil, 4=Organization, 5=Affiliate
			switch (type)
			{
				case "2":
					displayName = displayName + " Org: " + OrganizationList.SelectedItem.Text ;
					break ;
				case "3":
					displayName = displayName + " Affl: " +  AffiliationText.Text ;
					break ;
				case "4":
					displayName = OrganizationList.SelectedItem.Text ; ;
					break ;
				case "5":
					displayName = AffiliationText.Text ;
					break ;
				default:
					break ;
			}

			return displayName ;
		}

		private void DonationType(string type)
		{
			bIsActivityItem = false;

			switch (type)
			{
				case "1":
					//cash
					//GPFReqLabel.Visible = true ;
					//GPFLabel.Visible = true ;
					//GPFText1.Visible = false ;
					FSRLabel.Visible = true ;
					FSRText.Visible = true ;
					CheckLabel.Visible = false ;
					CheckNumberText.Visible = false ;
					CheckDateLabel.Visible = false ;
					StarCheckNumberLabel.Visible = false;
					CheckDate.Visible = false ;
					InMemLabel.Visible=true;
					InMemoryText.Visible=true;
					CheckNumberText.Text = "";
					CheckDate.Date = DateTime.MinValue;
					break ;
				case "2":
					//check
					//GPFReqLabel.Visible = true ;
					//GPFLabel.Visible = true ;
					//GPFText1.Visible = false ;
					FSRLabel.Visible = true ;
					FSRText.Visible = true ;
					CheckLabel.Visible = true ;
					CheckNumberText.Visible = true ;
					CheckDateLabel.Visible = true ;
					StarCheckNumberLabel.Visible = true;
					CheckDate.Visible = true ;
					InMemLabel.Visible=true;
					InMemoryText.Visible=true;
					break ;
				default:
					//3=item or 4=activity
					//GPFReqLabel.Visible = false ;
					//GPFLabel.Visible = false ;
					//GPFText1.Visible = false ;
					FSRLabel.Visible = false ;
					FSRText.Visible = false ;
					CheckLabel.Visible = false ;
					CheckNumberText.Visible = false ;
					CheckDateLabel.Visible = false ;
					StarCheckNumberLabel.Visible = false;
					CheckDate.Visible = false ;
					InMemLabel.Visible=false;
					InMemoryText.Visible=false;
					InMemoryText.Text = "";
					FSRText.Text = "";
					CheckNumberText.Text = "";
					CheckDate.Date = DateTime.MinValue;
					InMemoryText.Text = "";
					bIsActivityItem = true;
					break ;
			}
			SetDDList();
			ViewState["IsActivityItem"] = bIsActivityItem.ToString();
		}

		private void DonorType_Click(object sender, System.EventArgs e)
		{
			string donorType = DonorTypeList.SelectedItem.Value ;
			DonorType(donorType);
		}

		private void DonationType_Click(object sender, System.EventArgs e)
		{
			string donationType = DonationTypeList.SelectedItem.Value ;
			DonationType(donationType) ;
		}

		private string MissingFields()
		{
			bool comma = false ;
			string fields = string.Empty ;
			string donorType = DonorTypeList.SelectedItem.Value ;
			string donationType = DonationTypeList.SelectedItem.Value ;

/*			if (ValueText.Text == string.Empty)
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Value" ;
				comma = true ;
			} */
			//last name required for donors containing individual
			if (Convert.ToInt32(donorType) < 4 && (LastNameText.Text == string.Empty))
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Last Name" ;
				comma = true ;
			}
			//Organization required for donors containing organization
			if (OrganizationList.SelectedIndex < 1 && (donorType == "2" || donorType == "4"))
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Organization" ;
				comma = true ;
			}
			//Affiliation required for donors containing affiliation
			if (AffiliationText.Text == string.Empty && (donorType == "3" || donorType == "5"))
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Affiliation" ;
				comma = true ;
			}
			//GPF required for Donation type of monetary(cash & checks)
			if ((donationType == "1" || donationType == "2") && (ViewState["dsdndtl"].ToString() == string.Empty) || ((donationType == "1" || donationType == "2") && GPFGrid.Items.Count == 1))
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "General Post Fund Accounts" ;
				comma = true ;
			}
			
			string sValue = ValueLabel.Text;
			sValue = sValue.Remove(0,1);
			//GPF required for Donation type of monetary(cash & checks)
			if ((donationType == "3" || donationType == "4") && (Convert.ToDecimal(sValue) <= 0))
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Donation Amount" ;
				comma = true ;
			}

			return fields ;
		}

		private string CheckDates()
		{
			string errorMsg = string.Empty ;
			string msg = string.Empty ;
			bool comma = false ;
			DateTime donDate, ackDate ;
			//the setting of date is needed to force the the object to set the ValidateErrorMessage
			donDate = DonationDate.Date ;
			msg = DonationDate.ValidateErrorMessage ;
			//DonationDate is required, it is checked in MissingFields()
			if (msg != string.Empty && (msg == "Not selected"))
			{
				errorMsg = errorMsg + "Donation Date is required" ;
				comma = true ;
			}
			else
			{
				if (donDate == DateTime.MinValue)
				{
					errorMsg = "Donation Date is invalid" ;
					comma = true ;
				}
			}
			ackDate = AcknowledgementDate.Date ;
			msg = AcknowledgementDate.ValidateErrorMessage ;
			//Acknowledgement Date is optional, if we have a date it must be >= donDate
			if (msg == string.Empty && (ackDate < donDate))
			{
				if (comma)
				{ errorMsg = errorMsg + ", " ;}
				errorMsg = errorMsg + "Acknowledgement Date cannot be before Donation Date" ;
				comma = true ;
			}
			if (msg != string.Empty && (msg != "Not selected"))
			{
				if (comma)
				{ errorMsg = errorMsg + ", " ;}
				errorMsg = errorMsg + "Acknowledgement Date is invalid" ;
				comma = true ;
			}
			return errorMsg ;
		}

		private bool SaveData()
		{
			bool status = false ;
			Vha.Vtk.Donations.Donation donatHdl = null ;
			Vha.Vtk.Donations.Donor donorHdl = null ;
			int donationId = 0 ;
			int donorId = 0 ;
			int donationType ;
			int siteId = VtkPageHeader1.DivSelectedId ;
			bool versionOk = true ;
			try
			{
				string errorMsg = MissingFields() ;
				if (errorMsg != string.Empty)
				{
					//missing data, nothing posted
					VtkUtility.ErrMsgAdd(ErrorMessage, "The following fields are Required: " + errorMsg) ;
				}
				else
				{
					errorMsg = CheckDates() ;
					if (errorMsg != string.Empty)
					{
						//missing data, nothing posted
						VtkUtility.ErrMsgAdd(ErrorMessage, errorMsg) ;
					}
					else
					{
						//check donor record first
						if (ViewState["donorId"].ToString() != string.Empty)
						{
							//existing record, check version
							donorId = Convert.ToInt32(ViewState["donorId"].ToString()) ;
							donorHdl = new Vha.Vtk.Donations.Donor(donorId, VtkUtility.GetAppCon()) ;
							//check version
							if (ViewState["donorVersion"].ToString() != donorHdl.Version.ToString())
							{
								VtkUtility.ErrMsgAdd(ErrorMessage, "Current Program record has changed while you were editing, Please press EXIT and start over. ") ;
								versionOk = false ;
							}
						}
						else
						{
							//new existing record
							donorHdl = Vha.Vtk.Donations.Donor.AddRecord(VtkUtility.GetAppCon()) ;
						}
						if (ViewState["donationId"].ToString() != string.Empty)
						{
							//existing record, check version
							donationId = Convert.ToInt32(ViewState["donationId"].ToString()) ;
							donatHdl = new Vha.Vtk.Donations.Donation(donationId, VtkUtility.GetAppCon()) ;
							//check version
							if (ViewState["donatVersion"].ToString() != donatHdl.Version.ToString())
							{
								VtkUtility.ErrMsgAdd(ErrorMessage, "Current Program record has changed while you were editing, Please press EXIT and start over. ") ;
								versionOk = false ;
							}
						}
						else
						{
							//new existing record
							donatHdl = Vha.Vtk.Donations.Donation.AddRecord(VtkUtility.GetAppCon()) ;
						}
						if (versionOk)
						{
							//file donor record first
							donorHdl.LastName = LastNameText.Text ;
							donorHdl.FirstName = FirstNameText.Text ;
							donorHdl.MiddleName = MiddleNameText.Text ;
							donorHdl.NameSuffix = SuffixText.Text ;
							donorHdl.NamePrefix = NamePrefixText.Text ;
							donorHdl.Address1 = Address1Text.Text ;
							donorHdl.Address2 = Address2Text.Text ;
							donorHdl.City = CityText.Text ;
							donorHdl.Zip = ZipText.Text ;
							donorHdl.DonorAffiliation = AffiliationText.Text ;
							donorHdl.InstitutionId = siteId ;
							//set list values that are required
							donorHdl.DonorTypeId = Convert.ToInt32(DonorTypeList.SelectedItem.Value) ;
							//since the next 2 list aren't required, check that it was selected
							if (StateList.SelectedIndex > 0)
							{ donorHdl.StateId = Convert.ToInt32(StateList.SelectedItem.Value) ;}
							if (OrganizationList.SelectedIndex > 0)
							{donorHdl.OrganizationId = Convert.ToInt32(OrganizationList.SelectedItem.Value) ;}
							donorHdl.Save() ;
							donorId = donorHdl.ID ;
							//update viewstate incase they post again
							ViewState["donorId"] = donorId.ToString() ;
							ViewState["donorVersion"] = donorHdl.Version.ToString() ;
							ViewState["donorName"] = DonorName(DonorTypeList.SelectedItem.Value.ToString()) ;
							donorHdl.Dispose() ;

							//file donation record
							donatHdl.DonorId = donorId ;
							donationType = Convert.ToInt32(DonationTypeList.SelectedItem.Value) ;
							//donationType: 1=cash, 2=check, 3=item, 4=activity
							if (donationType < 3)
							{ donatHdl.IsMonetary = true ;}
							else
							{ donatHdl.IsMonetary = false ;}
							donatHdl.DonationTypeId = donationType ;
							donatHdl.DonationDate = DonationDate.Date ;
							if (ReferenceList.SelectedIndex >= 0)
							{ donatHdl.DonationReferenceFK = Convert.ToInt32(ReferenceList.SelectedItem.Value) ;}

//							donatHdl.DonationValue = Convert.ToDecimal(ValueText.Text) ;
							
							//DropDownList 
							System.IO.StringReader sr = new System.IO.StringReader((string)(ViewState["dsdndtl"]));
							dsdndtl = new DataSet();
							dsdndtl.ReadXml(sr);
							
							donatHdl.GeneralPostFund = dsdndtl.GetXml() ;
							donatHdl.CheckNumber = CheckNumberText.Text ;
							donatHdl.CheckDate = CheckDate.Date ;
							donatHdl.FieldServiceReceipt = FSRText.Text ;
							donatHdl.DonationDescription = DescriptionText.Text ;
							donatHdl.Designation = DesignationText.Text ;
							donatHdl.InMemoryOf = InMemoryText.Text ;
							donatHdl.Salutation = SalutationText.Text ;
							donatHdl.Post_Unit_Chapter = PUCText.Text ;
							donatHdl.AcknowledgementDate = AcknowledgementDate.Date ;
							donatHdl.InstitutionId = siteId ;
							donatHdl.CC1 = CCField1.Text;
							donatHdl.CC2 = CCField2.Text;
							donatHdl.CC3 = CCField3.Text;
							donatHdl.CC4 = CCField4.Text;
							donatHdl.CC5 = CCField5.Text;
							donatHdl.FamilyContact = FamilyContactText.Text;
							donatHdl.Save() ;
							//update viewstate incase they post again
							ViewState["donationId"] = donatHdl.ID.ToString() ;
							ViewState["donatVersion"] = donatHdl.Version.ToString() ;
							PopulateDonationDetails(Convert.ToInt32(ViewState["donationId"].ToString()));
							donatHdl.Dispose() ;
							//update confirmation message
							ConfirmationMessage.Text = "Record Posted! Donation Id is " + donatHdl.ID.ToString() ;
							status = true ;
						}
					}
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Donation Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Donation Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting Donation Record: " + err.Message) ;}
			return status ;
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			DataGridItem itm = GPFGrid.Items[GPFGrid.Items.Count-1];
			TextBox dValueText = (TextBox)itm.FindControl("DonationValueText");
			
			System.Decimal dValue = 0;

			try
			{
				dValue = (Convert.ToDecimal(dValueText.Text) * 100)/100 ;
				if (dValue > 0)
				{
					GPFGrid_EditCommand(null, null);
				}
				PostButton.Enabled = false ;
				bool status = SaveData() ;
				PostButton.Enabled = true ;
				DeleteButton.Enabled = true ;
				PrintButton.Enabled = true ;
			}
			catch (Exception err)
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, "Invalid Donation Value entered:" + err.Message) ;
			}
			
		}

		private void DeleteButton_Click(object sender, System.EventArgs e)
		{
			Vha.Vtk.Donations.Donation donatHdl = null ;
			int donationId = 0 ;
			try
			{
				if (ViewState["donationId"].ToString() != string.Empty)
				{
					//existing record, check version
					donationId = Convert.ToInt32(ViewState["donationId"].ToString()) ;
					donatHdl = new Vha.Vtk.Donations.Donation(donationId, VtkUtility.GetAppCon()) ;
					//check version
					if (ViewState["donatVersion"].ToString() != donatHdl.Version.ToString())
					{
						VtkUtility.ErrMsgAdd(ErrorMessage, "Current Program record has changed while you were editing, Please press EXIT and start over. ") ;
					}
					else
					{
						donatHdl.Delete() ;
						donatHdl.Save() ;
						donatHdl.Dispose() ;
						//clear fields
						ViewState["donationId"] = string.Empty ;
						ViewState["donatVersion"] = string.Empty ;
						DonationDate.Date = DateTime.Today ;
						//ReferenceText.Text = string.Empty ;
						//ValueText.Text = string.Empty ;
						//GPFText1.Text = string.Empty ;
						CheckNumberText.Text = string.Empty ;
						FSRText.Text = string.Empty ;
						DescriptionText.Text = string.Empty ;
						DesignationText.Text = string.Empty ;
						InMemoryText.Text = string.Empty ;
						SalutationText.Text = string.Empty ;
						PUCText.Text = string.Empty ;
						AcknowledgementDate.Date = DateTime.MinValue ;
						CheckDate.Date = DateTime.MinValue ;
						//set list values
						DonationTypeList.SelectedIndex = 0 ;
						//set list values
						ReferenceList.SelectedIndex = 0 ;
						//update confirmation message
						ConfirmationMessage.Text = "Donation Deleted!" ;
						//Exit to DonorChooser page
						Response.Redirect("DonorChooser.aspx?" + VtkPageHeader.GetURLParameterString() + "=" + VtkPageHeader1.DivSelectedId.ToString()) ;
					}
				}
				else
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting Donation Record, Please Exit and try again") ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting Donation Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting Donation Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting Donation Record: " + err.Message) ;}
		
		}

		private void FinishButton_Click(object sender, System.EventArgs e)
		{
			//if save data was successfull, than navigate, else stay on page
			if (SaveData())
			{
				//build url string to navigate to DonorChooser.aspx, add query strings
				StringBuilder sb = new StringBuilder("DonorChooser.aspx") ;
				sb.Append("?") ;
				//add division
				sb.Append(VtkPageHeader.GetURLParameterString()) ;
				sb.Append("=") ;
				sb.Append(VtkPageHeader1.DivSelectedId.ToString()) ;
				//goto new page
				Response.Redirect(sb.ToString()) ;
			}
		}

		private void GPFGrid_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			// get the row to delete; Cell[0]=Id
			string gpfFK = (string)e.Item.Cells[1].Text ;

			if ((gpfFK != "&nbsp;") && (gpfFK != "0"))
			{
				try
				{
					Int32 rowCnt = e.Item.ItemIndex;
					//DropDownList 
					System.IO.StringReader sr = new System.IO.StringReader((string)(ViewState["dsdndtl"]));
					dsdndtl = new DataSet();
					dsdndtl.ReadXml(sr);
					DataTable dtdndtl = dsdndtl.Tables["DonationDetails"];

					dtdndtl.Rows.RemoveAt(rowCnt);

					//Rebind the datasource to the Grid
					GPFGrid.DataSource = dtdndtl;
					GPFGrid.DataBind() ; 
					SetDDList();

					//save the ViewState
					System.IO.StringWriter sw = new System.IO.StringWriter();
					dsdndtl.WriteXml(sw);
					ViewState["dsdndtl"] = sw.ToString();
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting from General Post Fund Account: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting from General Post Fund Account: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting from General Post Fund Account: " + err.Message) ;}
			}
			else
			{VtkUtility.ErrMsgAdd(ErrorMessage, "This entry from the General Post Fund Accounts can not be deleted.") ;	}

		}
		private void GPFGrid_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			TextBox dValueText;
			DropDownList ddList;
			Int32 rowCnt;

			if (e == null)
			{

				DataGridItem itm = GPFGrid.Items[GPFGrid.Items.Count-1];
				ddList = (DropDownList)itm.FindControl("GPFList") ;
				dValueText = (TextBox)itm.FindControl("DonationValueText") ;
				rowCnt = itm.ItemIndex;
			}
			else
			{
				ddList = (DropDownList)e.Item.FindControl("GPFList") ;
				dValueText = (TextBox)e.Item.FindControl("DonationValueText") ;
				rowCnt = e.Item.ItemIndex;
			}

			System.Decimal dValue = 0;
			bool isGPFSelected = true;

			try
			{
				dValue = (Convert.ToDecimal(dValueText.Text) * 100)/100 ;
				if (dValue == 0)
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, "Donation Value can not be 0. Enter the Donation Value and then Save." ) ;
				}
			}
			catch (Exception err)
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, "Invalid Donation Value entered:" + err.Message) ;
			}

			if (ddList.SelectedItem.Value == "0")
			{
				isGPFSelected = false;
				VtkUtility.ErrMsgAdd(ErrorMessage, "GPC Account is not selected. Select GPF Account and then Update") ;
			}
			
			if (dValue > 0 && isGPFSelected)
			{
				Label lbl ;
				if (e == null)
				{
					DataGridItem itm = GPFGrid.Items[GPFGrid.Items.Count-1];
					lbl = (Label)itm.FindControl("StarLabel") ;
				}
				else
				{
					lbl = (Label)e.Item.FindControl("StarLabel") ;
				}
				lbl.Text="*";

				//DropDownList 
				System.IO.StringReader sr = new System.IO.StringReader((string)(ViewState["dsdndtl"]));
				dsdndtl = new DataSet();
				dsdndtl.ReadXml(sr);
				DataTable dtdndtl = dsdndtl.Tables["DonationDetails"];
			
				//Read the row from the dataset and set the values in the dataset 
				//to the updated values from the grid.
				DataRow dr = dtdndtl.Rows[rowCnt];
				dr["GeneralPostFund"] = ddList.SelectedItem.Text;
				dr["GeneralPostFundFK"] = ddList.SelectedItem.Value;
				dr["DonationValue"] = dValue.ToString();
				dr["Status"] = "*";

				//add the first row
				if (rowCnt == dtdndtl.Rows.Count-1)
				{
					bIsActivityItem = Convert.ToBoolean(ViewState["IsActivityItem"].ToString());
					//add the new row only if it is Activity or Item donation
					if (bIsActivityItem != true)
					{
						DataRow drdtl = dtdndtl.NewRow() ;
						drdtl["DonationSummaryFK"] = ViewState["donationId"].ToString();
						drdtl["GeneralPostFundFK"] = 0 ;
						drdtl["GeneralPostFund"] = "" ;
						drdtl["DonationValue"] = 0 ;
						drdtl["Status"] = "" ;
						dtdndtl.Rows.Add(drdtl);
					}
				}

				//Rebind the datasource to the Grid
				GPFGrid.DataSource = dtdndtl;
				GPFGrid.DataBind() ; 
				SetDDList();

				//save the ViewState
				System.IO.StringWriter sw = new System.IO.StringWriter();
				dsdndtl.WriteXml(sw, System.Data.XmlWriteMode.IgnoreSchema);
				ViewState["dsdndtl"] = sw.ToString();


				dtdndtl.Dispose();
			}
		}

		private void PrintButton_Click(object sender, System.EventArgs e)
		{
			//build url string to navigate to DonorChooser.aspx, add query strings
			StringBuilder sb = new StringBuilder("DonationPrint.aspx") ;
			sb.Append("?") ;
			//add division
			sb.Append(VtkPageHeader.GetURLParameterString()) ;
			sb.Append("=") ;
			sb.Append(VtkPageHeader1.DivSelectedId.ToString()) ;
			//add donation id
			sb.Append("&donationId=") ;
			sb.Append(ViewState["donationId"].ToString()) ;
			//add donor id is null, donor exist and referenced in donation
			sb.Append("&donorId=") ;
			// add donor name, need for label
			sb.Append("&donorName=") ;
			sb.Append(ViewState["donorName"].ToString()) ;
			//goto new page
			Response.Redirect(sb.ToString()) ;
		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.DonorTypeList.SelectedIndexChanged += new System.EventHandler(this.DonorType_Click);
			this.DonationTypeList.SelectedIndexChanged += new System.EventHandler(this.DonationType_Click);
			this.GPFGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.GPFGrid_EditCommand);
			this.GPFGrid.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.GPFGrid_DeleteCommand);
			this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
			this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
			this.PrintButton.Click += new System.EventHandler(this.PrintButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
