using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.WebControlLibrary;
using VTK.Utility;

namespace VTK.FileMaintenance
{
	/// <summary>
	/// Summary description for UserStaffEdit.
	/// </summary>  
	public class UserStaffEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.TextBox LastNameText;
		protected System.Web.UI.WebControls.TextBox FirstNameText;
		protected System.Web.UI.WebControls.TextBox MiddleNameText;
		protected System.Web.UI.WebControls.TextBox NickNameText;
		protected System.Web.UI.WebControls.RadioButtonList SexList;
		protected System.Web.UI.WebControls.TextBox EMailText;
		protected Vha.Vtk.WebControlLibrary.VtkCompositeDate StartDate;
		protected System.Web.UI.WebControls.DropDownList JobTitleList;
		protected System.Web.UI.WebControls.DropDownList ProgramList;
		protected System.Web.UI.WebControls.CheckBox LiasonCheckBox;
		protected System.Web.UI.WebControls.TextBox GradeText;
		protected System.Web.UI.WebControls.DropDownList RowList;
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.Button DeleteButton;
		protected System.Web.UI.WebControls.TextBox CommentText;
		protected System.Web.UI.WebControls.DataGrid StaffGrid;
		protected System.Web.UI.WebControls.CheckBox ChiefCheckBox;
		protected System.Web.UI.WebControls.Button NewButton;
		protected System.Web.UI.WebControls.DropDownList UserList;
		protected System.Web.UI.WebControls.Button CreateButton;
		protected System.Web.UI.WebControls.Label NewLabel;
		protected System.Web.UI.WebControls.Label CreateLabel;
		protected System.Web.UI.WebControls.Label CurrentLabel;
		protected System.Web.UI.WebControls.Label RecordLabel;
		protected System.Web.UI.WebControls.TextBox SuffixText;
		protected System.Web.UI.WebControls.Button PreviousButton;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try 
			{
				if (VtkPageHeader1.IsDivSelected("Voluntary Services")) 
				{
					if (!Page.IsPostBack)
					{
						int siteId = VtkPageHeader1.DivSelectedId ;
						GetStaffGrid(siteId) ;
						//initialize StartDate
						StartDate.YearListBegin = 1970 ;
						StartDate.YearListEnd = DateTime.Now.Year ;
						StartDate.InitializeControl() ;

						//get job title list, IsVolChiefSupervisor is a byte: 0=false, 1=true, 2=null
						DataSet tds = Vha.Vtk.ServicesDirectory.StaffTitle.GetQuickList(siteId, 0, VtkUtility.GetAppCon()) ;
						tds.Tables["StaffTitleList"].DefaultView.Sort = "Title ASC" ;
						DataTable tdt = tds.Tables["StaffTitleList"] ;
						//add the first row, uses Rows.InsertAt(
						DataRow tdr = tdt.NewRow() ;
						tdr["Title"] = " -Select Job Title- " ;
						tdr["Id"] = -1 ;
						tdt.Rows.InsertAt(tdr, 0) ;
						//define columns in list box
						JobTitleList.DataTextField = "Title" ;
						JobTitleList.DataValueField = "Id" ;
						JobTitleList.DataSource = tdt ;
						JobTitleList.DataBind() ;
						tds.Dispose() ;
						tdt.Dispose() ;

						//get supervised program list
						DataSet spds = Vha.Vtk.ServicesDirectory.SupervisedPrograms.GetQuickListByInstitutionId(siteId, VtkUtility.GetAppCon()) ;
						DataTable spdt = spds.Tables["SupervisedProgramsList"] ;
						//add the first row, uses Rows.InsertAt(
						DataRow spdr = spdt.NewRow() ;
						spdr["ProgramName"] = " -Select Program- " ;
						spdr["Id"] = -1 ;
						spdt.Rows.InsertAt(spdr, 0) ;
						//define columns in list box
						ProgramList.DataTextField = "ProgramName" ;
						ProgramList.DataValueField = "Id" ;
						ProgramList.DataSource = spdt ;
						ProgramList.DataBind() ;
						spds.Dispose() ;
						spdt.Dispose() ;

					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Staff List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Staff List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Staff List: " + err.Message) ;}

		}

		protected void SetFields(bool userEdit)
		{
			//set text fields to empty
			LastNameText.Text = string.Empty ;
			FirstNameText.Text = string.Empty ;
			MiddleNameText.Text = string.Empty ;
			NickNameText.Text = string.Empty ;
			EMailText.Text = string.Empty ;
			GradeText.Text = string.Empty ;
			CommentText.Text = string.Empty ;
			UserList.SelectedIndex = 0 ;
			JobTitleList.SelectedIndex = 0 ;
			ProgramList.SelectedIndex = 0 ;
			RowList.SelectedIndex = 0 ;
			SexList.ClearSelection() ;
			ChiefCheckBox.Checked = false ;
			LiasonCheckBox.Checked = false ;
			StartDate.Date = DateTime.MinValue ;
			//clear variables
			ViewState["usrId"] = string.Empty ;
			ViewState["usrVersion"] = string.Empty ;
			ViewState["ssId"] = string.Empty ;
			ViewState["ssVersion"] = string.Empty ;
			//set enable
			LastNameText.Enabled = userEdit ;
			FirstNameText.Enabled = userEdit ;
			MiddleNameText.Enabled = userEdit ;
			NickNameText.Enabled = userEdit ;
			EMailText.Enabled = userEdit ;
			GradeText.Enabled = userEdit ;
			CommentText.Enabled = userEdit ;
			JobTitleList.Enabled = userEdit ;
			ProgramList.Enabled = userEdit ;
			RowList.Enabled = userEdit ;
			SexList.Enabled = userEdit ;
			ChiefCheckBox.Enabled = userEdit ;
			LiasonCheckBox.Enabled = userEdit ;
			//these two fields are alway invisible, only set to visible at StaffGridEdit
			CurrentLabel.Visible = false ;
			RecordLabel.Visible = false ;
			DeleteButton.Enabled = false ;
			//enable post button
			PostButton.Enabled = userEdit ;
		}

		private void GetStaffGrid(int siteId)
		{
			//count is used to build RowList
			int count = 0 ;
			string isChief ;
			try
			{
				//get staff list
				DataSet sds = Vha.Vtk.ServicesDirectory.ServiceStaff.GetQuickListByInstitutionId(siteId, VtkUtility.GetAppCon()) ;
				DataTable sdt = sds.Tables["ServiceStaffList"] ;
				//add chief column
				sdt.Columns.Add("Chief", System.Type.GetType("System.String")) ;

				//loop and set chief to yes
				foreach (DataRow dr in sdt.Rows)
				{
					isChief = dr["IsChief"].ToString() ;
					if (isChief != string.Empty)
					{
						if (Convert.ToBoolean(isChief))
						{ dr["Chief"] = "Yes" ;}
					}
				}

				count = sdt.Rows.Count ;
				StaffGrid.DataSource = sdt ;
				StaffGrid.DataBind() ;
				sds.Dispose() ;
				sdt.Dispose() ;
				//build row list
				/*
				RowList.Items.Add(new ListItem("Row", "0")) ;
				for (int i=1; i<=count; i++)
				{
					RowList.Items.Add(new ListItem(i.ToString(),i.ToString()));
				}
				*/
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff Grid: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff Grid: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff Grid: " + err.Message) ;}
		}

		private void GetUserList(int siteId)
		{
			try
			{
				//get staff list
				DataSet sds = Vha.Vtk.Kernel.Data.SystemTables.User.GetQuickListByInstitutionId(siteId) ;
				DataTable sdt = sds.Tables["UserList"] ;
				//add the first row, uses Rows.InsertAt(
				DataRow sdr = sdt.NewRow() ;
				sdr["DisplayName"] = " -Select User- " ;
				sdr["ID"] = 0 ;
				sdt.Rows.InsertAt(sdr, 0) ;
				//define columns in list box
				UserList.DataTextField = "DisplayName" ;
				UserList.DataValueField = "ID" ;
				UserList.DataSource = sdt ;
				UserList.DataBind() ;
				sds.Dispose() ;
				sdt.Dispose() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the User List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the User List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the User List: " + err.Message) ;}
		}

		private string MissingFields()
		{
			string fields = string.Empty ;
			bool comma = false ;
			if (LastNameText.Text == string.Empty)
			{
				comma = true ;
				fields = "Last Name" ;
			}
			if (FirstNameText.Text == string.Empty)
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "First Name" ;
			}
			if (RowList.SelectedIndex < 1)
			{
				if (comma)
				{ fields = fields + ", " ;}
				fields = fields + "Insert after Row" ;
			}

			return fields ;
		}

		private void SetUserFields(Vha.Vtk.Kernel.Data.SystemTables.User usrhdl) 
		{
			//set text fields to values
			LastNameText.Text = usrhdl.LastName ;
			FirstNameText.Text = usrhdl.FirstName ;
			MiddleNameText.Text = usrhdl.MiddleName ;
			NickNameText.Text = usrhdl.Nickname ;
			GradeText.Text = usrhdl.Grade ;
			EMailText.Text = usrhdl.EMailAddress ;
			RecordLabel.Text = usrhdl.ID.ToString() ;
			if (usrhdl.JobTitleId > int.MinValue)
			{ VtkUtility.SetSelectedSingle(JobTitleList.Items, usrhdl.JobTitleId.ToString()) ;}
			if (usrhdl.Sex != string.Empty)
			{ VtkUtility.SetSelectedSingle(SexList.Items, usrhdl.Sex.ToString()) ;}
			if (usrhdl.PositionStartDate > DateTime.MinValue)
			{ StartDate.Date = usrhdl.PositionStartDate.Date ;}
			else
			{ StartDate.Date = DateTime.MinValue ;}
		}

		private void SetStaffFields(Vha.Vtk.ServicesDirectory.ServiceStaff sshdl)
		{
			CommentText.Text = sshdl.Comment ;
			ChiefCheckBox.Checked = sshdl.IsChief ;
			LiasonCheckBox.Checked = sshdl.IsVISNLiaison ;
			if (sshdl.ProgramId > int.MinValue)
			{ VtkUtility.SetSelectedSingle(ProgramList.Items, sshdl.ProgramId.ToString()) ;}
			else
			{ ProgramList.SelectedIndex = 0 ;}
			if (sshdl.ReportOrder > int.MinValue)
			{ VtkUtility.SetSelectedSingle(RowList.Items, sshdl.ReportOrder.ToString()) ;}
		}

		private void SetCreateFields(bool userSee)
		{
			//these are the fields to create a new user, only visible is they use create button
			NewLabel.Visible = userSee ;
			CreateLabel.Visible = userSee ;
			CreateButton.Visible = userSee ;
			UserList.Visible = userSee ;
		}

		private void DeleteRow(int ssId)
		{
			//renumber rows, skip ssId
			int currentId ;
			int currentRow ;
			int count = 0 ;
			//check the row number in the datagrid
			//loop thru grid and look for row change
			foreach (DataGridItem dgi in StaffGrid.Items)
			{
				count++ ;
				//serviceStaffId = Cell[0], ReportOrder = Cell[4]
				currentId = Convert.ToInt32(dgi.Cells[0].Text) ;
				currentRow = Convert.ToInt32(dgi.Cells[4].Text) ;
				if (ssId != currentId)
				{
					if (count != Convert.ToInt32(currentRow))
					{ ChangeRow(currentId, count) ;}
				}
				else  //if on ssId, this record is being deleted, skip and reset count
				{ count-- ;}
			}
		}

		private void UpRows(int afterRow, int ssId)
		{
			//insert ssId afterRow
			int currentId ;
			int currentRow ;
			int count = 0 ;
			bool update = false ;
			//loop thru grid and look for row to insert after
			foreach (DataGridItem dgi in StaffGrid.Items)
			{
				if (afterRow == 0 && (count == 0))
				{
					//set as first row
					update = true ;
					count++ ;
				}
				count++ ;
				//serviceStaffId = Cell[0], ReportOrder = Cell[4]
				currentId = Convert.ToInt32(dgi.Cells[0].Text) ;
				currentRow = Convert.ToInt32(dgi.Cells[4].Text) ;
				// stop changes if on current id
				if (ssId == currentId)
				{ update= false ;}
				if (update)
				{ ChangeRow(currentId, count) ;}
				//
				if (afterRow == currentRow)
				{
					update = true ;
					count++ ;
				}
			}
		}

		private void DownRows(int afterRow, int ssId)
		{
			//insert ssId afterRow
			int currentId ;
			int currentRow ;
			int count = 0 ;
			bool update = false ;
			//loop thru grid and look for row to insert after
			foreach (DataGridItem dgi in StaffGrid.Items)
			{
				count++ ;
				//serviceStaffId = Cell[0], ReportOrder = Cell[4]
				currentId = Convert.ToInt32(dgi.Cells[0].Text) ;
				currentRow = Convert.ToInt32(dgi.Cells[4].Text) ;
				if (update)
				{ ChangeRow(currentId, count) ;}
				// stop changes if on current row
				if (afterRow == currentRow)
				{ update= false ;}
				//
				if (ssId == currentId)
				{
					update = true ;
					count-- ;
				}
			}
		}

		private void ChangeRow(int ssId, int row)
		{
			//change the ReportOrder of ssId to row
			try
			{
				Vha.Vtk.ServicesDirectory.ServiceStaff sshdl = new Vha.Vtk.ServicesDirectory.ServiceStaff(ssId, VtkUtility.GetAppCon()) ;
				sshdl.ReportOrder = row ;
				sshdl.Save() ;
				sshdl.Dispose() ;
			}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the User List: " + err.Message) ;}
		}

		private void DeleteButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				string usrId = ViewState["usrId"].ToString() ;
				string usrNt = string.Empty ;
				string ssId = ViewState["ssId"].ToString() ;
				bool deleteOk = true ;
				//deletes the user from VtkVoluntaryServiceStaff and VtkUsers
				//check that we have a record, stored in viewstate
				if ((ssId == string.Empty) || (usrId == string.Empty))
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "Staff record is corrupted, please try again!") ;}
				//create handle for service staff and delete
				Vha.Vtk.ServicesDirectory.ServiceStaff sshdl = new Vha.Vtk.ServicesDirectory.ServiceStaff(Convert.ToInt32(ssId), VtkUtility.GetAppCon()) ;
				sshdl.Delete() ;
				sshdl.Save() ;
				sshdl.Dispose() ;

				//create handle for user
				Vha.Vtk.Kernel.Data.SystemTables.User usrhdl = new Vha.Vtk.Kernel.Data.SystemTables.User(Convert.ToInt32(usrId), VtkUtility.GetAppCon()) ;
				//need to check if we can delete from VtkUser, can't have user roles
				//must have NtUserName in order to have user roles
				if (usrhdl.NtUserName != null)
				{ usrNt = usrhdl.NtUserName ;}
				if (usrNt != string.Empty)
				{
					//have NTUserName, check if user has roles
					DataSet uds = Vha.Vtk.Kernel.Data.SystemTables.UserRole.GetUserRoleAtSites(usrNt, VtkUtility.GetAppCon()) ;
					if (uds.Tables["UserRolesAtSites"].Rows.Count > 0)
					{
						//user has roles, can't delete
						VtkUtility.ErrMsgAdd(ErrorMessage, "This User cannot be deleted, You need to delete this User's roles first!") ;
						deleteOk = false ;
					}
					uds.Dispose() ;
				}
				if (deleteOk)
				{
					//user doesn't have any roles, delete
					usrhdl.Delete() ;
					usrhdl.Save() ;
					//update confirmation message
					ConfirmationMessage.Text = "Record Deleted!" ;
				}	
				usrhdl.Dispose() ;

				//renumber and update DataGrid
				DeleteRow(Convert.ToInt32(ssId)) ;
				GetStaffGrid(VtkPageHeader1.DivSelectedId) ;
				SetFields(false) ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Staff Master Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Staff Master Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Staff Master Record: " + err.Message) ;}
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				//get Staff Id and the User Id
				string usrId = ViewState["usrId"].ToString() ;
				string ssId = ViewState["ssId"].ToString() ;
				int row = 0 ;
				int currentRow = 0 ;
				//flag to check if version number has changed
				bool versionOk = true ;
				int siteId = VtkPageHeader1.DivSelectedId ;
				//define handles
				Vha.Vtk.Kernel.Data.SystemTables.User usrhdl = null;
				Vha.Vtk.ServicesDirectory.ServiceStaff sshdl = null;
				//check for missing required fields
				string missingdata = MissingFields() ;
				if (missingdata != string.Empty)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following fields are Required: " + missingdata) ;}
				else
				{
					//check if new or existing VtkUser record
					if (usrId != string.Empty)
					{
						//create handle for user first
						usrhdl = new Vha.Vtk.Kernel.Data.SystemTables.User(Convert.ToInt32(usrId), VtkUtility.GetAppCon()) ;
						//check version number
						if (ViewState["usrVersion"].ToString() != usrhdl.Version.ToString())
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "Current User record has changed while you were editing, Please press EXIT and start over. ") ;
							versionOk = false ;
						}
						else
						{
							//check if new or existing VtkVoluntaryServiceStaff
							if (ssId != string.Empty)
							{
								//create handle for service staff
								sshdl = new Vha.Vtk.ServicesDirectory.ServiceStaff(Convert.ToInt32(ssId), VtkUtility.GetAppCon()) ;
								//check version number
								if (ViewState["ssVersion"].ToString()!= sshdl.Version.ToString())
								{
									VtkUtility.ErrMsgAdd(ErrorMessage, "Current User record has changed while you were editing, Please press EXIT and start over. ") ;
									versionOk = false ;
								}
							}
							else
							{
								//create new record for service staff
								sshdl = Vha.Vtk.ServicesDirectory.ServiceStaff.AddRecord(VtkUtility.GetAppCon()) ;
							}
						}
					}
					else
					{
						//user is new, so service staff must also be new
						usrhdl = Vha.Vtk.Kernel.Data.SystemTables.User.AddRecord(VtkUtility.GetAppCon()) ;
						sshdl = Vha.Vtk.ServicesDirectory.ServiceStaff.AddRecord(VtkUtility.GetAppCon()) ;
					}
					//records are open, set fields
					if (versionOk)
					{
						//set fields for VtkUser
						usrhdl.LastName = LastNameText.Text.Trim();
						usrhdl.FirstName = FirstNameText.Text.Trim();
						usrhdl.MiddleName = MiddleNameText.Text.Trim();
						usrhdl.Nickname = NickNameText.Text.Trim();
						usrhdl.Grade = GradeText.Text.Trim();
						usrhdl.EMailAddress = EMailText.Text.Trim();
						usrhdl.PrimaryInstitution = siteId ;
						if (StartDate.Date > DateTime.MinValue)
						{ usrhdl.PositionStartDate = StartDate.Date ;}
						if (JobTitleList.SelectedIndex > 0)
						{ usrhdl.JobTitleId = Convert.ToInt32(JobTitleList.SelectedItem.Value) ;}
						if (SexList.SelectedIndex > -1)
						{ usrhdl.Sex = SexList.SelectedItem.Value.ToString() ;}
						//save user information first, get id, need for service staff file
						usrhdl.Save() ;
						usrId = usrhdl.ID.ToString() ;
						usrhdl.Dispose() ;

						//set fields for VtkVoluntaryServiceStaff
						sshdl.UserId = Convert.ToInt32(usrId) ;
						sshdl.InstitutionId = siteId ;
						sshdl.Comment = CommentText.Text ;
						sshdl.IsChief = ChiefCheckBox.Checked ;
						sshdl.IsVISNLiaison = LiasonCheckBox.Checked ;
						if (ProgramList.SelectedIndex > 0)
						{ sshdl.ProgramId = Convert.ToInt32(ProgramList.SelectedItem.Value) ;}
						//check if Row is different
						if (RowList.SelectedIndex > 0)
						{
							row = Convert.ToInt32(RowList.SelectedItem.Value) ;
							currentRow = sshdl.ReportOrder ;
							//check if row they selected in within range, if larger than count, reset
							if (row > StaffGrid.Items.Count)
							{ row = StaffGrid.Items.Count ;}
							// check if existing record, currentRow > 0
							if (currentRow > 0)
							{
								//existing record, check if moving up or down in list
								if ((currentRow - row) > 0)
								{
									sshdl.ReportOrder = (row + 1) ;
									UpRows(row, Convert.ToInt32(ssId)) ;
								}
								if ((currentRow - row) < 0)
								{
									sshdl.ReportOrder = row ;
									DownRows(row, Convert.ToInt32(ssId)) ;
								}
							}
							else
							{
								//new record, add to end
								sshdl.ReportOrder = (row + 1) ;
								UpRows(row, 0) ;
							}
						}
						else
						{
							// this is for new records where the user reset rows to index of -1, report order is last number of grid
							//if (sshdl.ReportOrder == int.MinValue)
							//{ sshdl.ReportOrder = StaffGrid.Items.Count + 1 ;}
						}

						//save service staff file
						sshdl.Save() ;
						sshdl.Dispose() ;
						//update confirmation message
						ConfirmationMessage.Text = "Record Posted!" ;
						//update DataGrid
						GetStaffGrid(siteId) ;
						//clear fields
						SetFields(false) ;
					}
				}
			}

			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Service Staff record: " + err.Message) ;}
		}

		private void StaffGridEdit_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			SetCreateFields(false) ;
			// get the row to edit; Cell[0]=VoluntaryStaffId, Cell[1]=UserId, Cell[2]=TitleId
			string ssId = e.Item.Cells[0].Text ;
			string usrId = e.Item.Cells[1].Text ;
			try
			{
				//enable fields to be edited
				SetFields(true) ;
				//enable record fields
				CurrentLabel.Visible = true ;
				RecordLabel.Visible = true ;
				//create handle for user first
				Vha.Vtk.Kernel.Data.SystemTables.User usrhdl = new Vha.Vtk.Kernel.Data.SystemTables.User(Convert.ToInt32(usrId), VtkUtility.GetAppCon()) ;
				ViewState["usrId"] = usrhdl.ID ;
				ViewState["usrVersion"] = usrhdl.Version ;
				//set user fields and dispose
				SetUserFields(usrhdl) ;
				//enable delete only if user doesn't have NT user name, this means they can't have roles
				if (usrhdl.NtUserName == string.Empty)
				{ DeleteButton.Enabled = true ;}
				usrhdl.Dispose() ;

				//create handle for service staff
				Vha.Vtk.ServicesDirectory.ServiceStaff sshdl = new Vha.Vtk.ServicesDirectory.ServiceStaff(Convert.ToInt32(ssId), VtkUtility.GetAppCon()) ;
				//save Id and version
				ViewState["ssId"] = ssId ;
				ViewState["ssVersion"] = sshdl.Version.ToString() ;
				//set Staff fields and dispose
				SetStaffFields(sshdl) ;
				sshdl.Dispose() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff information: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff information: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff information: " + err.Message) ;}
		}

		private void StaffGridDelete_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			//deletes only from the service staff file
			SetCreateFields(false) ;
			// get the row to delete; Cell[0]=VoluntaryStaffId, Cell[1]=UserId, Cell[2]=TitleId
			string ssId = e.Item.Cells[0].Text ;
			try
			{
				//create handle for service staff
				Vha.Vtk.ServicesDirectory.ServiceStaff sshdl = new Vha.Vtk.ServicesDirectory.ServiceStaff(Convert.ToInt32(ssId), VtkUtility.GetAppCon()) ;
				sshdl.Delete() ;
				sshdl.Save() ;
				sshdl.Dispose() ;
				//renumber and refresh data grid
				DeleteRow(Convert.ToInt32(ssId)) ;
				GetStaffGrid(VtkPageHeader1.DivSelectedId) ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Service Staff: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Service Staff: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Service Staff: " + err.Message) ;}
		}

		private void NewButton_Click(object sender, System.EventArgs e)
		{
			SetFields(true) ;
			GetUserList(VtkPageHeader1.DivSelectedId) ;
			SetCreateFields(true) ;
			//if new service staff, set row to end of list
			RowList.SelectedIndex = (StaffGrid.Items.Count + 1) ;
		}

		private void UserList_Click(object sender, System.EventArgs e)
		{
			if (UserList.SelectedIndex > 0)
			{
				string usrId = UserList.SelectedItem.Value.ToString() ;
				SetCreateFields(false) ;
				try
				{
					//check if user is already in datagrid, show error if it is
					//create handle for user first
					Vha.Vtk.Kernel.Data.SystemTables.User usrhdl = new Vha.Vtk.Kernel.Data.SystemTables.User(Convert.ToInt32(usrId), VtkUtility.GetAppCon()) ;
					ViewState["usrId"] = usrhdl.ID ;
					ViewState["usrVersion"] = usrhdl.Version ;
					//set user fields and dispose
					SetUserFields(usrhdl) ;
					usrhdl.Dispose() ;
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Service Staff: " + err.Message) ;}
			}
		
		}

		private void CreateButton_Click(object sender, System.EventArgs e)
		{
			SetCreateFields(false) ;
			//set default value
			StartDate.Date = DateTime.Today ;
		}

		private void PreviousButton_Click(object sender, System.EventArgs e)
		{
		Response.Redirect("ServiceInformationEdit.aspx" + "?"+VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;
		}

		private void ExitButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("../Index.aspx" + "?"+VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
					private void InitializeComponent()
					{    
						this.StaffGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.StaffGridEdit_Click);
						this.StaffGrid.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.StaffGridDelete_Click);
						this.NewButton.Click += new System.EventHandler(this.NewButton_Click);
						this.UserList.SelectedIndexChanged += new System.EventHandler(this.UserList_Click);
						this.CreateButton.Click += new System.EventHandler(this.CreateButton_Click);
						this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
						this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
						this.PreviousButton.Click += new System.EventHandler(this.PreviousButton_Click);
						this.Load += new System.EventHandler(this.Page_Load);

					}
		#endregion

	}
}
