using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Security.Principal;
using Vha.Vtk.Common;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.WebControlLibrary;
using VTK.Utility;
using System.Text;
using Vha.Vss.Utility;
using Vha.Vtk.Games;

namespace VTK.Games
{
	/// <summary>
	/// Summary description for SingleDayPosting.
	/// </summary>
	public class GamesMultipleDayEdit : System.Web.UI.Page
	{
		protected System.Web.UI.HtmlControls.HtmlForm myForm;
		protected System.Web.UI.WebControls.Button PostButton;
		protected System.Web.UI.WebControls.DropDownList CombinationList;
		protected System.Web.UI.WebControls.DropDownList DayList;
		protected System.Web.UI.WebControls.DropDownList HourList;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Label DataGridHeader;
		protected System.Web.UI.WebControls.Button DeleteButton;
		protected System.Web.UI.WebControls.DataGrid TimeSheetDataGrid;
		protected System.Web.UI.WebControls.Button NewButton;
		protected System.Web.UI.WebControls.Label ChooseVolunteerLabel;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.DataGrid GameVolunteersGrid;
		protected System.Web.UI.WebControls.Button ResetButton;
		protected System.Web.UI.WebControls.Button SearchButton;
		protected System.Web.UI.WebControls.TextBox SearchText;
		protected System.Web.UI.WebControls.DropDownList SearchOptionList;
		protected System.Web.UI.WebControls.Panel SearchPanel;
		protected System.Web.UI.WebControls.Panel GameVolunteersPanel;
		protected System.Web.UI.WebControls.Panel PagerPanel;
		protected System.Web.UI.WebControls.ImageButton FIRST;
		protected System.Web.UI.WebControls.ImageButton Previous;
		protected System.Web.UI.WebControls.ImageButton Next;
		protected System.Web.UI.WebControls.ImageButton LAST;
		protected System.Web.UI.WebControls.DataGrid CombinationDataGrid;
		protected System.Web.UI.WebControls.DataGrid GamesList;
		protected System.Web.UI.WebControls.Button ChooseButton;
		protected System.Web.UI.WebControls.Label PageCount;
		protected System.Web.UI.WebControls.TextBox CurrentPage;
		protected System.Web.UI.WebControls.ImageButton GO;
		protected System.Web.UI.WebControls.Label IsVAEmployee;
		protected System.Web.UI.WebControls.Label VAEmployeeStatus;
		protected System.Web.UI.WebControls.Panel EditPanel;
	
		public GamesMultipleDayEdit()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try 
			{
				if (VtkPageHeader1.IsDivSelected("Multiple Days Hours"))
				{
					if (!Page.IsPostBack)
					{
						GamesList.Visible = false ;
						GameVolunteersPanel.Visible = true ;
						EditPanel.Visible = false ;
						TimeSheetDataGrid.Visible = false ;

						DataSet latestSchedule = GamesSchedule.GetQuickListByInstitutionId(Convert.ToInt32(VtkPageHeader1.DivSelectedId));
						DataTable scheduleDt = latestSchedule.Tables["GamesList"];

						/********************************************************************/
						/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
						/********************************************************************/
								
						if(scheduleDt.Rows.Count == 1)
						{
							ViewState["HostStationId"]	= scheduleDt.Rows[0]["HostInstitutionId"].ToString() ;
							ViewState["HostStationName"]= scheduleDt.Rows[0]["HostInstitutionName"].ToString() ;
							ViewState["GameTypeId"]		= scheduleDt.Rows[0]["GameTypeId"].ToString() ;
							ViewState["GameId"]			= scheduleDt.Rows[0]["ID"].ToString() ;
							ViewState["StartDate"]		= scheduleDt.Rows[0]["StartDate"].ToString() ;
							ViewState["EndDate"]		= scheduleDt.Rows[0]["EndDate"].ToString() ;
							ViewState["GameCode"]		= scheduleDt.Rows[0]["GameCode"].ToString() ;

							/********************************************************************/
							/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
							/********************************************************************/

							VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;						
							BuildDayList(Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), false) ;
						}
						else if (scheduleDt.Rows.Count > 1)
						{
							//display gamelist
							GamesList.Visible = true ;
							GameVolunteersPanel.Visible = false ;
							EditPanel.Visible = false ;
							TimeSheetDataGrid.Visible = true ;
						}
						else if (scheduleDt.Rows.Count == 0)
						{ VtkUtility.ErrMsgAdd(ErrorMessage, "You have no permissions for any Games!") ;}
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}	
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheet Record: " + err.Message) ;}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Section: Private Methods

		private void SetFields()
		{
			//clear fields
			DayList.SelectedIndex = 0 ;
			CombinationList.SelectedIndex =0 ;
			HourList.SelectedIndex = 0 ;
			ViewState["timeId"] = string.Empty ;
			ViewState["timeVersion"] = string.Empty ;
			DeleteButton.Enabled = false ;
		}

		private string MissingFields()
		{
			bool flag = false ;
			string fields = string.Empty ;
			if (ViewState["volId"] == null)
			{
				fields = "Volunteer" ;
				flag = true;
			}
			else if (Convert.ToInt32(CombinationList.SelectedItem.Value) < 0)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Combination Code" ;
				flag = true ;
			}
			if (DayList.SelectedIndex < 0)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Date" ;
				flag = true ;
			}
			if (HourList.SelectedIndex < 1)
			{
				if (flag)
				{ fields = fields + ", " ;}
				fields = fields + "Hours" ;
				flag = true ;
			}

			return fields ;
		}

		private void GetDataGrid(int volId, DateTime BeginDate, DateTime EndDate, string GameCode)
		{
			try
			{
				//populate list of TimeSheets for volId, for gameId
				DataSet dsts = VolunteerHours.GetQuickListForGamesByVolunteer(volId, BeginDate, EndDate, GameCode) ;
				dsts.Tables["GetQuickListForGamesByVolunteer"].DefaultView.Sort = "DateWorked" ;
				DataTable dtts = dsts.Tables["GetQuickListForGamesByVolunteer"] ;
				//bind datagrid to DataTable
				TimeSheetDataGrid.DataSource = dtts ;
				TimeSheetDataGrid.DataBind() ;

				dsts.Dispose() ;
				dtts.Dispose() ;

			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets Grid: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets Grid: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Time Sheets Grid: " + err.Message) ;}
		}

		private void GetCombinationList(int volId, int volStationId, string gameCode)
		{
			try
			{
				//populate list of Combination, get dataset
				//ref. Vha.Vtk.TimeKeeping.CombinationAssignment
				DataSet dscom = CombinationAssignment.GetQuickListForGames(volId, volStationId, gameCode) ;
				DataTable dtcom = dscom.Tables["CombinationAssignmentList"] ;

				//define columns in list box
				CombinationList.DataTextField = "DisplayName" ;
				CombinationList.DataValueField = "Id" ;
				// if no combinations, show message
				if (dtcom.Rows.Count < 1)
				{
					//add a row
					DataRow drcom = dtcom.NewRow() ;
					drcom["DisplayName"] = " *Volunteer has no Combination Code* " ;
					drcom["Id"] = "-1" ;
					dtcom.Rows.Add(drcom) ;
				}

				//bind list box to DataTable and cleanup
				CombinationList.DataSource = dtcom ;
				CombinationList.DataBind() ;
				//bind to datagrid
				CombinationDataGrid.DataSource = dtcom ;
				CombinationDataGrid.DataBind() ;
				dscom.Dispose() ;
				dtcom.Dispose() ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Combination List: " + err.Message) ;}
		}

		private void RefreshVolunteer()
		{
			int volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
			int volSiteId = Convert.ToInt32(ViewState["stnId"].ToString()) ;
			int gameId = Convert.ToInt32(ViewState["GameId"].ToString()) ;
			string gameCode = ViewState["GameCode"].ToString() ;

			//volunteer has been choosen, update viewstate and remove choosercontrol
			ChooseVolunteerLabel.Text = ViewState["VolunteerName"].ToString() ;
			DataGridHeader.Text = ViewState["VolunteerName"].ToString() ;
			GetDataGrid(volId, Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), ViewState["GameCode"].ToString()) ;
			GetCombinationList(volId, volSiteId, gameCode) ; 
		}

		private void BuildDayList(DateTime BeginDate, DateTime EndDate, bool SetTodaysDate)
		{
			string DateString;
			if(DayList.Items.Count != 0) DayList.Items.Clear();

			TimeSpan TimeInDays = EndDate - BeginDate;
			int days = TimeInDays.Days + 1;

			for(int i = 0; i < days; i++)
			{
				DateString = BeginDate.AddDays(Convert.ToDouble(i)).ToShortDateString();
				DayList.Items.Add(new ListItem(DateString, DateString));
				if(SetTodaysDate && (DateString == DateTime.Now.ToShortDateString()))
				{
					DayList.SelectedIndex = i;
					ViewState["date"] = BeginDate.AddDays(Convert.ToDouble(i));
				}
			}

			DayList.DataBind() ;
		}

		private void VolGridUpdate(int gameId)
		{
			//update GameVolunteersGrid
			//bind to grid: [0]=Id, [1]=volId, [2]=stationId, [3]=profileId, [5]=volName, [6]=ssn, [7]=station 
			string sText = string.Empty ;
			string sOption = string.Empty ;
			//check if we have search string
			if (SearchText.Text.Length > 0)
			{ sText = SearchText.Text ;}
			sOption = SearchOptionList.SelectedItem.Value ;

			DataSet ds = Vha.Vtk.Games.GamesRegistration.GetQuickListByGameSchedule(gameId) ;
			//if we have search field, do search, else do sort
			if (sText != string.Empty)
			{ ds.Tables["GamesRegistrationList"].DefaultView.RowFilter =  sOption + " LIKE '" + sText + "*'" ;}
			else
			{ ds.Tables["GamesRegistrationList"].DefaultView.Sort = sOption ;}
			DataTable dt = ds.Tables["GamesRegistrationList"] ;
			//if no rows, show 'no volunteer registered' message and not pager panel
			if (dt.Rows.Count == 0)
			{
				PagerPanel.Visible = false ;
				SearchPanel.Visible = false ;
			}
			else
			{
				GameVolunteersGrid.DataSource = dt ;
				GameVolunteersGrid.DataBind() ;
				SetPagerStats();
				PagerPanel.Visible = true ;
				SearchPanel.Visible = true ;
			}
			ds.Dispose() ;
			dt.Dispose() ;
		}

		private bool RecordExists()
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Added routine to check now primary key components.
			for (int i = 0; i < TimeSheetDataGrid.Items.Count; i++)
			{
				DateTime dViewStateDate, dGridDate;
				dViewStateDate = Convert.ToDateTime(ViewState["date"].ToString());
				dGridDate = Convert.ToDateTime(TimeSheetDataGrid.Items[i].Cells[1].Text);

				if( ViewState["volId"].ToString() == TimeSheetDataGrid.Items[i].Cells[5].Text &&
					ViewState["stnId"].ToString() == TimeSheetDataGrid.Items[i].Cells[6].Text  &&
					ViewState["orgId"].ToString() == TimeSheetDataGrid.Items[i].Cells[7].Text  &&
					ViewState["svcId"].ToString() == TimeSheetDataGrid.Items[i].Cells[8].Text  &&
					ViewState["schId"].ToString() == TimeSheetDataGrid.Items[i].Cells[9].Text  &&
					dViewStateDate.ToShortDateString() == dGridDate.ToShortDateString() )
						return true;
			}
			return false;
		}

		#endregion

		#region Section: Private Events

		private void Register_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				
				/********************************************************************/
				/*               SAVE THE DATA FROM GAMESLIST PAGE    							*/
				/********************************************************************/
				ViewState["HostStationId"]	= e.Item.Cells[0].Text;
				ViewState["HostStationName"]= e.Item.Cells[3].Text;
				ViewState["GameTypeId"]		= e.Item.Cells[1].Text;
				ViewState["GameId"]			= e.Item.Cells[2].Text;
				ViewState["StartDate"]		= e.Item.Cells[5].Text;
				ViewState["EndDate"]		= e.Item.Cells[6].Text;
				ViewState["GameCode"]		= e.Item.Cells[7].Text;

				/********************************************************************/
				/*               SETUP FOR VOLUNTEER REGISTRATION INFO							*/
				/********************************************************************/

				VolGridUpdate(Convert.ToInt32(ViewState["GameId"].ToString())) ;
				BuildDayList(Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), true) ;
				GamesList.Visible = false ;
				GameVolunteersPanel.Visible = true ;
				EditPanel.Visible = false ;

			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Games List: " + err.Message) ;}
		}

		private void ChooseButton_Click(object sender, System.EventArgs e)
		{
			//select a new volunteer
			ViewState["volId"] = null ;
			ViewState["VolunteerName"] = null ;
			ViewState["stnId"] = null ;
			GamesList.Visible = false ;
			GameVolunteersPanel.Visible = true ;
			EditPanel.Visible = false ;
		}

		private void EditButton_Click(object sender, System.EventArgs e)
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Removed ID as primary key added Vol ID, Stn ID, Org ID,
			// Svc ID, Sch ID and Dateworked as primary key.

			//get selected timesheet
			int ivolId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[5].Text);
			int istnId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[6].Text);
			int iorgId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[7].Text);
			int isvcId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[8].Text);
			int ischId = Convert.ToInt32(TimeSheetDataGrid.SelectedItem.Cells[9].Text);
			DateTime ddate = Convert.ToDateTime(TimeSheetDataGrid.SelectedItem.Cells[1].Text);

			try
			{
				//create handle and save id and version
				Vha.Vtk.TimeKeeping.VolunteerHours tshdl = new Vha.Vtk.TimeKeeping.VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;
				// set current month and year in header
				SetFields() ;
				//set viewstate variables
				ViewState["volId"] = tshdl.VolunteerId ;
				ViewState["stnId"] = tshdl.StationId ;
				ViewState["orgId"] = tshdl.OrganizationId ;
				ViewState["svcId"] = tshdl.BenefitingServiceId ;
				ViewState["schId"] = tshdl.ScheduleId ;
				ViewState["date"] = tshdl.DateWorked ;
				ViewState["timeVersion"] = tshdl.Version.ToString();
				//populate fields
				if (tshdl.DateWorked > DateTime.MinValue)
				{ VtkUtility.SetSelectedSingle(DayList.Items, tshdl.DateWorked.ToShortDateString()) ;}
				else
				{ DayList.SelectedIndex = 0 ;}

				if (tshdl.HoursWorked > 0)
				{ VtkUtility.SetSelectedSingle(HourList.Items, tshdl.HoursWorked.ToString()) ;}
				else
				{ HourList.SelectedIndex = 0 ;}

				int org = tshdl.OrganizationId ;
				int svc = tshdl.BenefitingServiceId ;
				int sch = tshdl.ScheduleId ;
				int comId = int.MinValue ;

				foreach (DataGridItem dgi in CombinationDataGrid.Items)
				{
					if (dgi.Cells[1].Text == org.ToString())
					{
						if (dgi.Cells[2].Text == sch.ToString())
						{
							if (dgi.Cells[3].Text == svc.ToString())
							{ comId = Convert.ToInt32(dgi.Cells[0].Text) ;}
						}
					}
				}
				if (comId > int.MinValue)
				{
					VtkUtility.SetSelectedSingle(CombinationList.Items,comId.ToString());
				}
				//enable buttons
				DeleteButton.Enabled = true ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Timesheet Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Timesheet Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Timesheet Record: " + err.Message) ;}
		}

		private void PostButton_Click(object sender, System.EventArgs e)
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Removed ID as primary key added Vol ID, Stn ID, Org ID,
			// Svc ID, Sch ID and Dateworked as primary key.
			try
			{
				//check for required fields
				string missingdata = MissingFields() ;
				if (missingdata != string.Empty)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "The following field(s) are Required: " + missingdata) ;}
				else
				{
					//convert DayList to date
					DateTime DateWorked = Convert.ToDateTime(DayList.SelectedItem.Text) ;
					//disable post button until we are done
					PostButton.Enabled = false ;
					//flag to check if version number has changed
					bool versionOk = true ;
					int volId = Convert.ToInt32(ViewState["volId"].ToString()) ;
					Vha.Vtk.TimeKeeping.VolunteerHours tshdl ;

					//existing record
					if (RecordExists())
					{
						int ivolId = Convert.ToInt32(ViewState["volId"].ToString());
						int istnId = Convert.ToInt32(ViewState["stnId"].ToString());
						int iorgId = Convert.ToInt32(ViewState["orgId"].ToString());
						int isvcId = Convert.ToInt32(ViewState["svcId"].ToString());
						int ischId = Convert.ToInt32(ViewState["schId"].ToString());
						DateTime ddate = Convert.ToDateTime(ViewState["date"].ToString());
						
						//create handle and open current record
						tshdl = new VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;

						//check version
						if (ViewState["timeVersion"].ToString() != tshdl.Version.ToString())
						{
							VtkUtility.ErrMsgAdd(ErrorMessage, "Current Volunteer Time Sheet record has changed while you were editing, Please press EXIT and start over. ") ;
							versionOk = false ;
						}
					}
						//new record
					else
					{
						//create handle and open new record
						tshdl = VolunteerHours.AddRecord(volId, VtkUtility.GetAppCon()) ;
					}
					if (versionOk)
					{
						//save current fields
						tshdl.StationId = Convert.ToInt32(ViewState["stnId"]) ;
						tshdl.DateWorked = DateWorked ;
						tshdl.HoursWorked = Convert.ToInt32(HourList.SelectedItem.Value.ToString()) ;
						//seperate combination, find in datagrid
						string comId = CombinationList.SelectedItem.Value.ToString() ;
						int org = int.MinValue ;
						int sch = int.MinValue ;
						int svc = int.MinValue ;

						foreach (DataGridItem dgi in CombinationDataGrid.Items)
						{
							if (dgi.Cells[0].Text == comId)
							{
								org = Convert.ToInt32(dgi.Cells[1].Text) ;
								sch = Convert.ToInt32(dgi.Cells[2].Text) ;
								svc = Convert.ToInt32(dgi.Cells[3].Text) ;
								break ;
							}
						}
						tshdl.OrganizationId = org ;
						tshdl.ScheduleId = sch ;
						tshdl.BenefitingServiceId = svc ;

						//save and close
						tshdl.Save() ;
						tshdl.Dispose() ;
						//update confirmation message
						ConfirmationMessage.Text = "Record Posted!" ;
						
						RefreshVolunteer();
						GetDataGrid(volId, Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), ViewState["GameCode"].ToString()) ;
						BuildDayList(Convert.ToDateTime(ViewState["StartDate"].ToString()),  Convert.ToDateTime(ViewState["EndDate"].ToString()), true);
						HourList.SelectedIndex = 0 ;
						DeleteButton.Enabled = false ;
					}
				}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Timesheet Record: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Timesheet Record: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error posting the Timesheet Record: " + err.Message) ;}
			finally
			{ PostButton.Enabled = true ;}

		}

		private void NewButton_Click(object sender, System.EventArgs e)
		{
			SetFields() ;
		}

		private void DeleteButton_Click(object sender, System.EventArgs e)
		{
			// MSG 11/22/2004 Hour's breakout change.
			// Removed ID as primary key added Vol ID, Stn ID, Org ID,
			// Svc ID, Sch ID and Dateworked as primary key.

			if (RecordExists())
			{
				//get id of existing record
				int ivolId = Convert.ToInt32(ViewState["volId"].ToString());
				int istnId = Convert.ToInt32(ViewState["stnId"].ToString());
				int iorgId = Convert.ToInt32(ViewState["orgId"].ToString());
				int isvcId = Convert.ToInt32(ViewState["svcId"].ToString());
				int ischId = Convert.ToInt32(ViewState["schId"].ToString());
				DateTime ddate = Convert.ToDateTime(ViewState["date"].ToString());


				Vha.Vtk.TimeKeeping.VolunteerHours tshdl ;
				try
				{
					//create handle and open current record
					tshdl = new VolunteerHours(ivolId, istnId, iorgId, ischId, isvcId, ddate, VtkUtility.GetAppCon()) ;
					//delete, save and close
					tshdl.Delete() ;
					tshdl.Save() ;
					tshdl.Dispose() ;

					//update confirmation message
					ConfirmationMessage.Text = "Record Deleted!" ;
					//update DataGrid
					GetDataGrid(ivolId, Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), ViewState["GameCode"].ToString()) ;					
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Timesheet Record: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Timesheet Record: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error deleting the Timesheet Record: " + err.Message) ;}
			}
		}

		private void VolGridEdit_Click(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try
			{
				//get information from grid
				ViewState["VolunteerName"] = e.Item.Cells[5].Text.ToString() ;
				ViewState["volId"] = e.Item.Cells[1].Text.ToString() ;
				ViewState["stnId"] = e.Item.Cells[2].Text.ToString() ;
				ViewState["VAEmployee"] = e.Item.Cells[8].Text.ToString() ;
				ViewState["VAEmployeeStatus"] = e.Item.Cells[9].Text.ToString() ;
				
				//clean fields and setup to edit registration
				SetFields() ;
				ChooseVolunteerLabel.Text = ViewState["VolunteerName"].ToString() ;
				DataGridHeader.Text = ViewState["VolunteerName"].ToString();
				IsVAEmployee.Text = ViewState["VAEmployee"].ToString();
				VAEmployeeStatus.Text = ViewState["VAEmployeeStatus"].ToString();

				RefreshVolunteer() ;
				BuildDayList(Convert.ToDateTime(ViewState["StartDate"].ToString()), Convert.ToDateTime(ViewState["EndDate"].ToString()), true);
				//Set the Correct Panels
				GamesList.Visible = false ;
				GameVolunteersPanel.Visible = false ;
				EditPanel.Visible = true ;
				TimeSheetDataGrid.Visible = true ;
			} 
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading Volunteer Information: " + err.Message) ;}
		}

		private void SearchButton_Click(object sender, System.EventArgs e)
		{
			if (SearchText != null)
			{
				try
				{
					GameVolunteersGrid.CurrentPageIndex = 0;
					VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
				}
				catch (VhaValidationException valErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
				catch (VhaTransactionException transErr)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
				catch (Exception err)
				{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
			}
			else
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "You must enter a Name to use for searching!") ;}
		}

		private void ResetButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				//reset search fields
				SearchText.Text = string.Empty ;
				SearchOptionList.SelectedIndex = 0 ;
				GameVolunteersGrid.CurrentPageIndex = 0;
				VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error searching the table: " + err.Message) ;}
		}

		private void ExitButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("../Index.aspx?" + VtkPageHeader.GetURLParameterString() + "=" + VtkPageHeader1.DivSelectedId.ToString());
		}

		#endregion

		#region Paging Data

		private void PageGrid(object obj, DataGridPageChangedEventArgs e)
		{
			GameVolunteersGrid.CurrentPageIndex = 0;
			VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
		}

		private void SetPagerStats()
		{
			int currentPageIndex = GameVolunteersGrid.CurrentPageIndex + 1;
			int pageCount = GameVolunteersGrid.PageCount;
			
			CurrentPage.Text = currentPageIndex.ToString();
			PageCount.Text = pageCount.ToString();
			//PageStats.Text = "Page " + currentPageIndex.ToString() + " of " + pageCount.ToString();
		}

		private void Pager_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{			
			ImageButton objSender = (ImageButton)sender;
			switch(objSender.CommandArgument)
			{
				case "PREV":
					if(GameVolunteersGrid.CurrentPageIndex > 0)
						GameVolunteersGrid.CurrentPageIndex --;
					break;
				case "NEXT":
					if(GameVolunteersGrid.CurrentPageIndex < (GameVolunteersGrid.PageCount - 1))
						GameVolunteersGrid.CurrentPageIndex ++;
					break;
				case "GO":
					if((Convert.ToInt32(CurrentPage.Text) <= GameVolunteersGrid.PageCount) && (Convert.ToInt32(CurrentPage.Text) != 0))
					{
						GameVolunteersGrid.CurrentPageIndex = Convert.ToInt32(CurrentPage.Text) - 1;
					}
					break;
				case "FIRST":
					GameVolunteersGrid.CurrentPageIndex = 0;
					break;
				case "LAST":					
					GameVolunteersGrid.CurrentPageIndex = GameVolunteersGrid.PageCount - 1;
					break;
			}
			CurrentPage.Text = GameVolunteersGrid.CurrentPageIndex.ToString();
			VolGridUpdate(Convert.ToInt32(ViewState["GameId"])) ;
		}
		#endregion

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GamesList.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Register_Click);
			this.SearchButton.Click += new System.EventHandler(this.SearchButton_Click);
			this.ResetButton.Click += new System.EventHandler(this.ResetButton_Click);
			this.GameVolunteersGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.PageGrid);
			this.GameVolunteersGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.VolGridEdit_Click);
			this.FIRST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Previous.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.GO.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.Next.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.LAST.Click += new System.Web.UI.ImageClickEventHandler(this.Pager_Click);
			this.DayList.SelectedIndexChanged += new System.EventHandler(this.OnDayList_Change);
			this.PostButton.Click += new System.EventHandler(this.PostButton_Click);
			this.NewButton.Click += new System.EventHandler(this.NewButton_Click);
			this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
			this.ChooseButton.Click += new System.EventHandler(this.ChooseButton_Click);
			this.TimeSheetDataGrid.SelectedIndexChanged += new System.EventHandler(this.EditButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void OnDayList_Change(object sender, System.EventArgs e)
		{
			ViewState["date"] = DayList.SelectedItem.ToString();
		}

	}
}
