namespace VTK.National
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Web;
    using System.Web.SessionState;
    using System.Web.UI;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;

	using CrystalDecisions.Web;
	using CREngine = CrystalDecisions.CrystalReports.Engine;
	using CrystalDecisions.CrystalReports.Engine;
	using CrystalDecisions.Shared;
	using System.Data.SqlClient;
	using System.Diagnostics;
	
	using Vha.Vtk;
	using Vha.Vss.Utility;
	using VTK.Utility;
	using VTK.RptCR;
	using VTK.DailyTimeKeeping;
	using VTK.Volunteer;
	using System.Configuration;

    /// <summary>
    ///    Summary description for CrystalWeb.
    /// </summary>
    public class NationalCrystalWeb : System.Web.UI.Page
    {
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label DateRangeLabel;
		protected CrystalDecisions.Web.CrystalReportViewer CrystalReportViewer1;

		private IDictionary config;
		internal UIReportParams par = null;
		internal CREngine.ReportDocument rpt = null;
		private CREngine.Database crDatabase;
		private CREngine.Tables crTables;
		private TableLogOnInfo crTableLogOnInfo;
		private ConnectionInfo crConnectionInfo;

		private CREngine.Sections crSections;
		private CREngine.ReportObjects crReportObjects;
		private CREngine.SubreportObject crSubReportObject;

	public NationalCrystalWeb()
	{
		try
		{
			config = (IDictionary)ConfigurationSettings.GetConfig("VssConfiguration/DSN");
		}
		catch{}
	    Page.Init += new System.EventHandler(Page_Init);
        }

        protected void Page_Load(object sender, EventArgs e)
        {
			//VtkUtility.PageCacheDisable(Page.Response);
			if (!IsPostBack) 
			{
				try 
				{
					//UIReportParams par = RptUtility.GetParams(Context,ViewState);
					/* string transferId=Request.Params["transferId"];
					UIReportParams par = (UIReportParams)Session[transferId]; 
					Session.Remove(transferId);
					Vha.Vtk.WebControlLibrary.VhaWebUtility.EndTransaction(Session,transferId);*/
					UIReportParams par = RptUtility.GetParams(Context);
					if (par.ReportFormat == UIReportFormat.Web) 
					{
						// Check that Request.Params["rpt"]==par.ReportType.ToString()
						if (Request.Params["rpt"]!=par.ReportType.ToString()) 
						{
							VtkUtility.ErrMsgAdd(ErrorMessage,"rpt QueryString does not match report type found in Session.","CrystalWeb");
						} 
						else 
						{
							// Load report parameters if this is the first time
							RptUtility.LoadReportParamsWeb(par, CrystalReportViewer1.ParameterFieldInfo);
						}
					} 
					else 
					{
						// TODO: error condition
					}
				} 
				catch (Exception err) 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
				}
			}
		}

		protected void LoadReport() 
		{
			// call this from Page_Init (BEFORE viewstate is restored) to load report into CR Viewer.
			string reportName = Request.Params["rpt"];
			ReportDocument rpt = null;
			// load the report
			RptUtility.LoadReport(reportName, out rpt);
			//Creating connection to database from ODBC 
			DataEncoder dataDecoder = new DataEncoder("VhaVss");
			crConnectionInfo = new ConnectionInfo();
			crConnectionInfo.ServerName = (string)config["Name"];
			crConnectionInfo.UserID = (string)config["UserId"];
			crConnectionInfo.Password = dataDecoder.DecodeString(((string)config["Password"]).Substring(1, ((string)config["Password"]).Length - 2));
			crConnectionInfo.DatabaseName = (string)config["DBName"];

			//Looping thru each Table on the report to add the connection
			crDatabase = rpt.Database;
			crTables = crDatabase.Tables;
  
			foreach (CREngine.Table crTable in crTables)
			{
				crTableLogOnInfo = crTable.LogOnInfo;
				crTableLogOnInfo.ConnectionInfo = crConnectionInfo;
				crTable.ApplyLogOnInfo(crTableLogOnInfo);
			}
        
			//Looping Through each of the sections, Reports in those sections, 
			//and SubReports in those Reports.
			crSections = rpt.ReportDefinition.Sections;
			foreach (CREngine.Section crSection in crSections)
			{
				crReportObjects = crSection.ReportObjects;
				foreach(CREngine.ReportObject crReportObject in crReportObjects)
				{
					if(crReportObject.Kind == ReportObjectKind.SubreportObject)
					{
						crSubReportObject = (CREngine.SubreportObject)crReportObject;
						crDatabase = crSubReportObject.OpenSubreport(crSubReportObject.SubreportName).Database;
						crTables = crDatabase.Tables;

						foreach(CREngine.Table crTable in crTables)
						{
							crTableLogOnInfo = crTable.LogOnInfo;
							crTableLogOnInfo.ConnectionInfo = crConnectionInfo;
							crTable.ApplyLogOnInfo(crTableLogOnInfo);              
						}
					}
				}
			}
			CrystalReportViewer1.ReportSource = rpt;
		}

		protected void Page_Init(object sender, EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP+ Windows Form Designer.
            //
            InitializeComponent();
			LoadReport();
        }

        /// <summary>
        ///    Required method for Designer support - do not modify
        ///    the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}

		private void DivisionChange(object sender, System.EventArgs e)
		{

		}
	}
}
