using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.WebControlLibrary;
using Vha.Vtk.Kernel.Common;
using VTK.Utility;
using System.Text;
using CrystalDecisions.Shared;
using CrystalDecisions.CrystalReports.Engine;

namespace VTK.National
{
	/// <summary>
	/// Summary description for AgeGroupCounts.
	/// </summary>
	public class UtilizingServicesSubdivision : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList FiscalYearList;
		protected System.Web.UI.WebControls.RadioButtonList PrintFormatList;
		protected System.Web.UI.WebControls.DropDownList EndMonthList;
		protected System.Web.UI.WebControls.RadioButtonList ReportTypeList;
		protected System.Web.UI.WebControls.Label ConfirmationMessage;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Button PrintButton;
	
		public UtilizingServicesSubdivision()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Utilizing Services and Subdivisions"))
				{
					if (!Page.IsPostBack)
					{
						InitializeYearList();
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + err.Message) ;}
		}

		private void InitializeYearList() 
		{
			int year=VtkUtility.GetCurrentFiscalYear();
			// is 30 enough?
			for (int i=year;i>year-30;i--)
			{
				FiscalYearList.Items.Add(new ListItem(i.ToString(),i.ToString()));
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.PrintButton.Click += new System.EventHandler(this.PrintButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void PrintButton_Click(object sender, System.EventArgs e)
		{
			if (ValidateForm()) 
			{
				UIReportParams rp = new UIReportParams();

				// FiscalYear
				rp.AT_InFY=Convert.ToInt32(FiscalYearList.SelectedItem.Value);

				// End Month (add 1 to get range of 2 to 13 for sproc)
				rp.AT_InEndMonth=Convert.ToInt32(EndMonthList.SelectedItem.Value)+1;

				// Report Type
				if (ReportTypeList.SelectedItem.Value=="I") 
				{
					rp.ReportType=UIReportType.VtkUtilizingServicesSubdivisionsI;
				} 
				else if (ReportTypeList.SelectedItem.Value=="II") 
				{
					rp.ReportType=UIReportType.VtkUtilizingServicesSubdivisionsII;
				} 
				else // problem
				{
					rp.ReportType=UIReportType.None;
				}

				// report format
				rp.ReportFormat=RptUtility.GetUIReportFormat(PrintFormatList.SelectedItem.Value);

				// Put UIParams into Context
				Context.Items["ReportParams"]=rp;

				if (rp.ReportFormat==UIReportFormat.Web) 
				{
					Server.Transfer(RptUtility.GetNationalCrystalWebTransferString(rp.ReportType));
				} 
				else 
				{
					Server.Transfer("NationalCrystalExport.aspx");
				}
			}
		}

		public class UIReportParams : VTK.Utility.UIReportParams 
		{
			public int AT_InFY;
			public int AT_InEndMonth;

			public UIReportParams() 
			{
				AT_InFY=0;
				AT_InEndMonth=0;
			}
		}
		
		private bool ValidateForm() 
		{
			bool printOKFlag=true;
			// nothing to do here, Fiscal Year and Month are always selected
			return printOKFlag;
		}

	}
}
