using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.Kernel.Common;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using System.Text;

namespace VTK.Reports
{
	/// <summary>
	/// Summary description for DonationsDataView.
	/// </summary>
	public class DonationsDataView : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label KeyLabel;
		protected System.Web.UI.WebControls.DataGrid DataGrid;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
		try
			{
				if (VtkPageHeader1.IsDivSelected("Donations Data View"))
				{
					if (!Page.IsPostBack)
					{
						// get parameters and build data grid
						string instlist = Request.QueryString["inst"];
						DateTime begindate = Convert.ToDateTime(Request.QueryString["begindate"]);
						DateTime enddate = Convert.ToDateTime(Request.QueryString["enddate"]);
						string donationtype = Request.QueryString["donationtype"];
						int value = Convert.ToInt32(Request.QueryString["value"]);
						string gpf = Request.QueryString["gpf"];
						string check = Request.QueryString["check"];
						string lastname = Request.QueryString["lastname"];
						string org = Request.QueryString["org"];
						string localbranch = Request.QueryString["localbranch"];
						string othgroups = Request.QueryString["othgroups"];
						string reference = Request.QueryString["reference"];
						string memory = Request.QueryString["memory"];
						bool fSD = Convert.ToBoolean(Request.QueryString["fSD"]); //station detail
						bool fIN = Convert.ToBoolean(Request.QueryString["fIN"]); //individual name
						bool fOG = Convert.ToBoolean(Request.QueryString["fOG"]); //individual affiliation (other groups)
						bool fIA = Convert.ToBoolean(Request.QueryString["fIA"]); //individual address
						bool fOR = Convert.ToBoolean(Request.QueryString["fOR"]); //organization
						bool fCD = Convert.ToBoolean(Request.QueryString["fCD"]); //check data
						bool fR  = Convert.ToBoolean(Request.QueryString["fR"]);  //reference
						bool fD  = Convert.ToBoolean(Request.QueryString["fD"]);  //description
						bool fAD = Convert.ToBoolean(Request.QueryString["fAD"]); //ack date
						bool fPU = Convert.ToBoolean(Request.QueryString["fPU"]); //post unit chapter
						bool fIM = Convert.ToBoolean(Request.QueryString["fIM"]); //in memory of
						bool fS  = Convert.ToBoolean(Request.QueryString["fS"]);  //salutation
						bool fCC = Convert.ToBoolean(Request.QueryString["fCC"]); //cc
						bool fFC = Convert.ToBoolean(Request.QueryString["fFC"]); //family contact

						
						UpdateDataGrid(instlist, begindate, enddate, donationtype, value, gpf, check, lastname, org, localbranch, othgroups, reference, memory,
							           fSD, fIN, fOG, fIA, fOR, fCD, fR, fD, fAD, fPU, fIM, fS, fCC, fFC);
						//set key box
						KeyLabel.Text = "Begin Date = " + begindate.ToShortDateString() + "    End Date = " + enddate.ToShortDateString();
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
					//Response.Flush();
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Donations List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Donations List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Donations List: " + err.Message) ;}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void UpdateDataGrid(string instlist, System.DateTime begindate, System.DateTime enddate, string donationtype, int value,
			                        string gpf, string check, string lastname, string org, string localbranch, string othgroups, string reference, string memory,
									bool fSD, bool fIN, bool fOG, bool fIA, bool fOR, bool fCD, bool fR, bool fD, bool fAD, bool fPU, bool fIM, bool fS, bool fCC, bool fFC)
		{
			DataSet dsData;
			DataTable dtData;
			string displayName = string.Empty ;
			string error = "";
			if (error != string.Empty)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, error) ;}
			else
			{
				//get the data for the report
				dsData = Vha.Vtk.Donations.Donation.GetQuickListDataForDonationSearch(instlist, begindate.ToShortDateString(), enddate.ToShortDateString(), donationtype, value, gpf, check, lastname, org, localbranch, othgroups, reference, memory);
				dtData = dsData.Tables["GetQuickListDataForDonationSearch"];
				
				DataGrid.DataSource = dtData;
				DataGrid.DataBind();

				// ----- SHOW SELECTED DATA -----
				//station detail
				if (fSD == false)
				{
					DataGrid.Columns[1].Visible = false;
					DataGrid.Columns[2].Visible = false;
				}
				//organization
				if (fOR == false)
				{
					DataGrid.Columns[5].Visible = false;
					DataGrid.Columns[6].Visible = false;
				}
				//individual name
				if (fIN == false)
				{
					DataGrid.Columns[7].Visible = false;
					DataGrid.Columns[8].Visible = false;
					DataGrid.Columns[9].Visible = false;
					DataGrid.Columns[10].Visible = false;
					DataGrid.Columns[11].Visible = false;
				}
				//individual affiliation (other groups)
				if (fOG == false) DataGrid.Columns[12].Visible = false;
				//individual address
				if (fIA == false)
				{
					DataGrid.Columns[13].Visible = false;
					DataGrid.Columns[14].Visible = false;
					DataGrid.Columns[15].Visible = false;
					DataGrid.Columns[16].Visible = false;
					DataGrid.Columns[17].Visible = false;
				}
				//check data
				if (fCD == false)
				{
					DataGrid.Columns[20].Visible = false;
					DataGrid.Columns[21].Visible = false;
				}
				//reference
				if (fR == false) DataGrid.Columns[23].Visible = false;
				//description
				if (fD == false) DataGrid.Columns[24].Visible = false;
				//ack date
				if (fAD == false) DataGrid.Columns[25].Visible = false;
				//post unit chapter
				if (fPU == false) DataGrid.Columns[26].Visible = false;
				//in memory of
				if (fIM == false) DataGrid.Columns[27].Visible = false;
				//salutation
				if (fS == false) DataGrid.Columns[28].Visible = false;
				//cc
				if (fCC == false)
				{
					DataGrid.Columns[29].Visible = false;
					DataGrid.Columns[30].Visible = false;
					DataGrid.Columns[31].Visible = false;
					DataGrid.Columns[32].Visible = false;
					DataGrid.Columns[33].Visible = false;
				}
				//family contact
				if (fFC == false) DataGrid.Columns[34].Visible = false;

				dsData.Dispose();
				dtData.Dispose();

			}
		}
	}
}
