using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.Kernel.Common;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using System.Text;

namespace VTK.Reports
{
	/// <summary>
	/// Summary description for VNONationalOfficialsDataView.
	/// </summary>
	public class VNONationalOfficialsDataView : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid NatOffDataGrid;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				//Response.Buffer = true;
				//string reportFormat = Request.QueryString["ReportFormat"];
				//Page.Trace.Warn(reportFormat);
				//Response.ContentType = reportFormat;
				//Response.AddHeader("content-disposition", "inline; filename=" + GetDocType(reportFormat));

				if (VtkPageHeader1.IsDivSelected("National Officials Data View"))
				{
					if (!Page.IsPostBack)
					{
						// populate the national officials grid
						GetOfficialsList() ;
					}
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}

				//Response.Flush();
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Programs List: " + err.Message) ;}
		}

		//protected string GetDocType(string ReportFormat)
		//{
		//	string docType = String.Empty;
		//	switch(ReportFormat)
		//	{
		//		case "application/vnd.ms-word":
		//		case "application/x-msword":
		//		case "application/msword":
		//			docType = "VNONationalOfficialsReport.doc";
		//			break;
		//		case "application/vnd.ms-excel":
		//		case "application/x-msexcel":
		//		case "application/msexcel":
		//			docType = "VNONationalOfficialsReport.xls";
		//			break;
		//		case "text/html":
		//			docType = "VNONationalOfficialsReport.aspx";
		//			break;
		//		case "application/pdf":
		//			docType = "VNONationalOfficialsReport.pdf";
		//			break;
		//		default:
		//			docType = "VNONationalOfficialsReport.aspx";
		//			break;
		//	}
		//	return docType;
		//}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void GetOfficialsList()
		{
			try
			{
				// get the state table data for linking using StateId primary key
				DataSet dsState = Vha.Vtk.Kernel.Data.SystemTables.State.GetQuickList();
				DataTable dtState = dsState.Tables["StateList"];
				dtState.DefaultView.Sort = "Abbreviation ASC";
				// create the primary key on the Id for the state table (needed for looking up)
				DataColumn[] pkState = new DataColumn[1];
				pkState[0] = dtState.Columns["Id"];
				dtState.PrimaryKey = pkState;


				// get the organization table data for linking using OrganizationId primary key
				DataSet dsOrganization = Vha.Vtk.Common.Organization.GetQuickList();
				DataTable dtOrganization = dsOrganization.Tables["OrganizationList"];
				dtOrganization.DefaultView.Sort = "Name ASC";
				// create the primary key on the Id for the state table (needed for looking up)
				DataColumn[] pkOrg = new DataColumn[1];
				pkOrg[0] = dtOrganization.Columns["Id"];
				dtOrganization.PrimaryKey = pkOrg;


				// get the list of national officials sorted by last name
				DataSet dsNatOff = Vha.Vtk.NationalOfficials.NationalOfficials.GetQuickList();
				dsNatOff.Tables["NationalOfficialsList"].DefaultView.Sort = "LastName ASC";
				DataTable dtNatOff = dsNatOff.Tables["NationalOfficialsList"];


				// create a results table (rt) to allow for ordering columns to display
				DataTable dtResults = new DataTable("Results");
				dtResults.Columns.Add(new DataColumn("ID", typeof(int)));
				dtResults.Columns.Add(new DataColumn("Rep or Dep", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Last Name", typeof(string)));
				dtResults.Columns.Add(new DataColumn("First Name", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Middle Name", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Prefix", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Suffix", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Title", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Code", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Name", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Abbreviation", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Is Inactive", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Scope", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization Is On NAC", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization NAC Executive Member", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization NAC Membership Status", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Organization AJR Month", typeof(int)));
				dtResults.Columns.Add(new DataColumn("Street Address", typeof(string)));
				dtResults.Columns.Add(new DataColumn("City", typeof(string)));
				dtResults.Columns.Add(new DataColumn("State", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Zip", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Telephone", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Date Appointed", typeof(string)));
				dtResults.Columns.Add(new DataColumn("Is NCO", typeof(string)));
				DataRow drResults;


				// loop the national officials data rows and add the data to the results table (rt)
				foreach (DataRow drNatOff in dtNatOff.Rows)
				{
					// add a new row to the results table and set the data
					drResults = dtResults.NewRow();
					drResults["ID"] = drNatOff["Id"];
					drResults["Rep or Dep"] = drNatOff["NationalRepORNationalDep"];
					drResults["Last Name"] = drNatOff["LastName"];
					drResults["First Name"] = drNatOff["FirstName"];
					drResults["Middle Name"] = drNatOff["MiddleName"];
					drResults["Prefix"] = drNatOff["NamePrefix"];
					drResults["Suffix"] = drNatOff["NameSuffix"];
					drResults["Title"] = drNatOff["Title"];

					// create a datarow for finding the organization based on OrganizationId
					DataRow foundRow;
					// create an array for the key values to find
					object[]findTheseVals = new object[1];
					// set the values of the keys to find
					findTheseVals[0] = drNatOff["OrganizationId"];
					// find the row with the value
					foundRow = dtOrganization.Rows.Find(findTheseVals);
					// set the column [2 = code] of the row found in the organization field
					drResults["Organization Code"] = "";
					if(foundRow != null) 
					{
						drResults["Organization Code"] = foundRow[2];
						drResults["Organization Name"] = foundRow[1];
						drResults["Organization Abbreviation"] = foundRow[4];
						drResults["Organization Is Inactive"] = foundRow[5];
						drResults["Organization Scope"] = foundRow[6];
						drResults["Organization Is On NAC"] = foundRow[8];
						drResults["Organization NAC Executive Member"] = foundRow[9];
						drResults["Organization NAC Membership Status"] = foundRow[10];
						drResults["Organization AJR Month"] = foundRow[11];
					}

					drResults["Street Address"] = drNatOff["StreetAddress1"];
					drResults["City"] = drNatOff["City"];

					// create a datarow for finding the state based on StateId
					findTheseVals[0] = drNatOff["StateId"];
					// find the row with the value
					foundRow = dtState.Rows.Find(findTheseVals);
					// set the column [3 = abbreviation] of the row found in the state field
					drResults["State"] = "";
					if(foundRow != null) drResults["State"] = foundRow[3];

					drResults["Zip"] = drNatOff["Zip"];
					drResults["Telephone"] = drNatOff["Telephone"];
					// get rid of the time
					if (drNatOff["DateAppointed"] != System.DBNull.Value) drResults["Date Appointed"] = Convert.ToString(Convert.ToDateTime(drNatOff["DateAppointed"]).ToShortDateString());
					drResults["Is NCO"] = drNatOff["IsNationalCertifyingOfficial"];

					dtResults.Rows.Add(drResults);
				}


				DataView dvResults = new DataView(dtResults);
				NatOffDataGrid.DataSource = dvResults;
				NatOffDataGrid.DataBind();

				// clean up
				dsNatOff.Dispose();
				dtNatOff.Dispose();
				dtResults.Dispose();
				dsState.Dispose();
				dtState.Dispose();
				dsOrganization.Dispose();
				dtOrganization.Dispose();
			}
			catch (VhaValidationException valErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Officials List: " + valErr.Message) ;}
			catch (VhaTransactionException transErr)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Officials List: " + transErr.Message) ;}
			catch (Exception err)
			{ VtkUtility.ErrMsgAdd(ErrorMessage, "There was an error loading the Officials List: " + err.Message) ;}
		}
	}
}
