using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Vha.Vtk.Kernel.Common;
using Vha.Vtk;
using Vha.Vtk.TimeKeeping;
using VTK.Utility;
using Vha.Vtk.WebControlLibrary;
using System.Text;
using CrystalDecisions.Shared;
using CrystalDecisions.CrystalReports.Engine;
using VTK.RptCR;


namespace VTK.Reports
{
	/// <summary>
	/// Summary description for VolunteerDailyReview.
	/// </summary>
	public class VolunteerDailyReview : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button PrintButton;
		protected System.Web.UI.WebControls.RadioButtonList PrintFormatList;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.TextBox txtEndDate;
		protected System.Web.UI.WebControls.CompareValidator BeginEndDateValidator;
		protected System.Web.UI.WebControls.RequiredFieldValidator BeginDateValidator;
		protected Vha.Vtk.WebControlLibrary.VtkPageHeader VtkPageHeader1;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Label NameLabel;
		protected System.Web.UI.WebControls.RangeValidator BeginDateRangeValidator;
		protected System.Web.UI.WebControls.RangeValidator EndDateRangeValidator;
		protected System.Web.UI.WebControls.Panel EditPanel;
		protected System.Web.UI.WebControls.Panel ChooserPanel;
		protected VTK.Volunteer.VolunteerChooserControl VolunteerChooserControl1;
		protected System.Web.UI.WebControls.TextBox txtBeginDate;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				if (VtkPageHeader1.IsDivSelected("Volunteer Daily Review"))
				{
					if (!Page.IsPostBack)
					{
						//set the selected datetime to today
						
						txtBeginDate.Text=System.Convert.ToString(System.DateTime.Today.ToShortDateString());
						txtEndDate.Text=System.Convert.ToString(System.DateTime.Today.ToShortDateString());

						//check if we are coming from volunteer chooser
//						if (Context.Items["vtkVolunteerChooserSuccess"]!=null) 
//						{
//							if (Convert.ToBoolean(Context.Items["vtkVolunteerChooserSuccess"])) 
//							{
//								// set the selected volunteer for the print button
//								ViewState["volId"] = Context.Items["vtkVolunteerChooserId"];
//								// fill the name into the text box
//								NameLabel.Text = Context.Items["vtkVolunteerChooserName"].ToString();
//							} 
//							else 
//							{
//								//no volunteer chosen, go back index
//								StringBuilder sb = new StringBuilder(Request.ApplicationPath);
//								sb.Append("/index.aspx?");
//								sb.Append(VtkPageHeader.GetURLParameterString());
//								sb.Append("=");
//								sb.Append(VtkPageHeader1.DivSelectedId.ToString());
//								Response.Redirect(sb.ToString()); 
//							}
//						}
//						else 
//						{
//							//don't have a voluteer, Go to chooser:
//							// 1. set return page
//							StringBuilder sb = new StringBuilder(Request.ApplicationPath);
//							sb.Append("/Reports/VolunteerDailyReview.aspx?");
//							sb.Append(VtkPageHeader.GetURLParameterString());
//							sb.Append("=");
//							sb.Append(VtkPageHeader1.DivSelectedId.ToString());
//							Context.Items["vtkVolunteerChooserReturnPage"]=sb.ToString();
//							// 2. transfer
//							sb = new StringBuilder("/VTK/Volunteer/VolunteerChooser.aspx?");
//							sb.Append(VtkPageHeader.GetURLParameterString());
//							sb.Append("=");
//							sb.Append(VtkPageHeader1.DivSelectedId.ToString());
//							Server.Transfer(sb.ToString());
//						}
					} 
					//save the stationId on the form
					Page.RegisterHiddenField("StationId", VtkPageHeader1.DivSelectedId.ToString()) ;
				}
				else
				{ Response.Redirect("/Vtk/Welcome.aspx?" + VtkPageHeader.GetURLParameterString()+"=" + VtkPageHeader1.DivSelectedId) ;}
			}
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
			}
		}

		override protected bool OnBubbleEvent(object Sender, EventArgs e) 
		{
			bool bubbleValue = false ;
			if (VolunteerChooserControl1.VolunteerChooserSuccess)
			{
				Page.RegisterHiddenField("CheckForBlank", "true");
				ViewState["volId"] = VolunteerChooserControl1.VolunteerChooserId.ToString() ;
				ViewState["volName"] = VolunteerChooserControl1.VolunteerChooserName.ToString() ;
				VolunteerChooserControl1.BubbleEventClear() ;
				// fill the name into the text box
				NameLabel.Text = ViewState["volName"].ToString();
				//turn off chooser
				ChooserPanel.Visible = false ;
				EditPanel.Visible = true ;
				bubbleValue = true ;
			}
			return bubbleValue ;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.PrintButton.Click += new System.EventHandler(this.PrintButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
		private void PrintButton_Click(object sender, System.EventArgs e)
		{
			//run report
			UIReportParams rp = new UIReportParams();
			// selected volunteer
			rp.AT_InputVolunteerId = Convert.ToInt32(ViewState["volId"]);
			// begin date
			rp.AT_InputBeginDate=System.Convert.ToDateTime(txtBeginDate.Text);
			// end date
			rp.AT_InputEndDate=System.Convert.ToDateTime(txtEndDate.Text);
			// report type
			rp.ReportType=UIReportType.VtkSL_VolunteerDailyReview;
			// report format
			rp.ReportFormat=RptUtility.GetUIReportFormat(PrintFormatList.SelectedItem.Value);

			// Put UIParams into Context
			Context.Items["ReportParams"]=rp;
			// transfer
			if (rp.ReportFormat==UIReportFormat.Web) 
			{
				Server.Transfer(RptUtility.GetCrystalWebTransferString(rp.ReportType, VtkPageHeader1, Request.ApplicationPath));
			} 
			else 
			{
				Server.Transfer("../RptCR/CrystalExport.aspx");
			}
		}

		public class UIReportParams : VTK.Utility.UIReportParams 
		{
			public int AT_InputVolunteerId;
			public DateTime AT_InputBeginDate;
			public DateTime AT_InputEndDate;

			public UIReportParams() 
			{
				AT_InputVolunteerId=0;
				AT_InputBeginDate=DateTime.Today;
				AT_InputEndDate=DateTime.Today;
			}
		}
	}
}
