using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace VTK.Utility
{
	/// <summary>
	/// Summary description for Calendar.
	/// </summary>
	public class Calendar : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Calendar ListDate;
		protected System.Web.UI.WebControls.Literal DatePassBack;
		protected String FieldToUpdate;
		protected String FormatDate;
		protected String SelectionMode;
		protected bool IsAutoPostBack = false;
		private void Page_Load(object sender, System.EventArgs e)
		{
			FieldToUpdate = Request["field"];
			Page.RegisterHiddenField("FieldToUpdate", FieldToUpdate);

			FormatDate = Request["dateFormat"];
			Page.RegisterHiddenField("FormatDate", FormatDate);

			SelectionMode = Request["selectionMode"];
			Page.RegisterHiddenField("SelectionMode", SelectionMode);
			
			if(Request["IsAutoPostBack"] == "true")
				IsAutoPostBack = true;
			else
				IsAutoPostBack = false;

			switch (SelectionMode)
			{
				case ("DayWeekMonth"):
					ListDate.SelectionMode = CalendarSelectionMode.DayWeekMonth;
					break;
				case ("DayWeek"):
					ListDate.SelectionMode = CalendarSelectionMode.DayWeek;
					break;
				case ("Day"):
					ListDate.SelectionMode = CalendarSelectionMode.Day;
					break;
				case ("None"):
					ListDate.SelectionMode = CalendarSelectionMode.None;
					break;
			}
	}
		public void ListDate_OnSelectionChanged(object sender, System.EventArgs e)
		{
			string txtDate = ListDate.SelectedDate.ToShortDateString();
			string formatDate = Request.Form["FormatDate"];
			string fieldUpdate = Request.Form["FieldToUpdate"];
			
			if (formatDate == "MonthYearFormat")
			{
				txtDate = ListDate.SelectedDate.ToString("M/yyyy");
			}

			if(fieldUpdate == String.Empty)
				fieldUpdate = "txtDateTime";

			StringBuilder javaScript  = new StringBuilder("\n<Script language=\"JavaScript\">\n");
			javaScript.Append("    var txtField = window.opener.document.forms(0)." + fieldUpdate + ";\n");
			javaScript.Append("    txtField.value='" + txtDate + "';\n");
			if(IsAutoPostBack)
			{
				javaScript.Append("    txtField.fireEvent('onchange');\n");
			}
			javaScript.Append("    window.close();\n");
			javaScript.Append("</Script" + ">");
			DatePassBack.Text = javaScript.ToString();
		}
		public void ListDate_VisibleMonthChanged(object sender, MonthChangedEventHandler e)
		{
			
		}
		public void ListDate_OnDayRender(object sender, DayRenderEventArgs e)
		{
			
		}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ListDate.SelectionChanged += new System.EventHandler(this.ListDate_OnSelectionChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
