using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;
using Vha.Vtk.WebControlLibrary;
using VtkUser.Utility;

namespace VtkUser
{
	/// <summary>
	/// Summary description for PrintMealTicket.
	/// </summary>
	public class PrintMealTicket : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button PrintButton;
		protected System.Web.UI.WebControls.Literal ticket;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			int numberOfMeals = Convert.ToInt32(Request.QueryString["NumberOfMeals"].ToString()) ;
//			string price = string.Format("{0:F2}", Convert.ToDecimal(Request.QueryString["Price"])) ;
			string price = Request.QueryString["Price"] ;

			StringBuilder MealTicket = new StringBuilder();
			for (int i=0; i<numberOfMeals; i++)
			{
				MealTicket.Append("\n");
				MealTicket.Append("\n****       *****\n");
				MealTicket.Append(" ****     *******  VOLUNTEER\n");
				MealTicket.Append("  ****   **** ****   MEAL\n");
				MealTicket.Append("   **** ****   **** TICKET\n");
				MealTicket.Append("    ******* ********\n");
				MealTicket.Append("     ***** **********\n\n");
					    
				MealTicket.Append(Request.QueryString["Name"] + "\n\n");
					    
//				MealTicket.Append("Date: " + Request.QueryString["Time"] + "\n\n");
				MealTicket.Append("Date: " + Convert.ToDateTime(Request.QueryString["Time"]).ToShortDateString() + "\n\n");
					    
				MealTicket.Append("   NOT VALID FOR \n");
				MealTicket.Append("  MORE THAN $" + price + "\n\n");

				MealTicket.Append("         ^\n");
				MealTicket.Append("        /|\\\n\n");
					        
				MealTicket.Append("____________________________\n");
				MealTicket.Append("Signature Of Volunteer\n");
				MealTicket.Append("         |\n");
				MealTicket.Append("         I\n");
				MealTicket.Append("         M\n");
				MealTicket.Append("         P\n");
				MealTicket.Append("         R\n");
				MealTicket.Append("         I\n");
				MealTicket.Append("VA FORM 10-3558\n");
				MealTicket.Append("         N\n");
				MealTicket.Append("For use by Voluntary \n");
				MealTicket.Append("    Service ONLY\n");
				MealTicket.Append("         T\n");
				MealTicket.Append("\n");
				MealTicket.Append("\n");
			}
			ticket.Text = MealTicket.ToString();
			//save the stationId on the form, needed when moving to next page
			Page.RegisterHiddenField("StationId", Request.QueryString["SiteId"].ToString()) ;

			//file data into MealTicket table

			//get values save in MealTick.aspx
			DateTime clientTime = Convert.ToDateTime(Request.QueryString["Time"].ToString()) ;
			int siteId = Convert.ToInt32(Request.QueryString["SiteId"].ToString()) ;
			int volId = Convert.ToInt32(Request.QueryString["VolId"].ToString()) ;
			Vha.Vtk.MealTickets.MealsProvided mthdl = Vha.Vtk.MealTickets.MealsProvided.AddRecord(VtkUtility.GetAppCon()) ;
			mthdl.DateOfMeal = clientTime.Date ;
			mthdl.InstitutionId = siteId ;
			mthdl.VolunteerId = volId ;
			mthdl.IsReprinted = false ;
			mthdl.NumberOfMeals = numberOfMeals ;
			mthdl.HowAdded = "A" ;
			mthdl.TimeLastPrinted = DateTime.Now ;
			mthdl.Save() ;
			mthdl.Dispose() ;

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
