using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Web.Security;
using Vha.Vtk.WebControlLibrary;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.TimeKeeping;
using VtkUser.Utility;
using System.Resources;
using System.Threading;
using System.Globalization;
using System.Reflection;
using System.Xml;
using System.Xml.XPath;
using Vha.Vss.Utility;

namespace VtkUser
{
	/// <summary>
	/// Summary description for Timecard.
	/// </summary>
	public class Timecard : System.Web.UI.Page
	{
		protected string OnLoadEvent = "";
		protected System.Web.UI.WebControls.Literal MetaRefresh;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Button HoursButton;
		protected System.Web.UI.WebControls.Label EnterHoursLabel;
		protected System.Web.UI.WebControls.DropDownList HourList;
		protected Vha.Vtk.WebControlLibrary.VtkUserPageHeader VhaVtkUserPageHeader1;
		protected System.Web.UI.WebControls.Label HeadingLabel;
		protected System.Web.UI.HtmlControls.HtmlInputHidden TimeLabel;

		protected System.Web.UI.HtmlControls.HtmlGenericControl myBody;
		protected System.Web.UI.WebControls.Label AlreadyLabel1;
		protected System.Web.UI.WebControls.Label AlreadyLabel2;
		protected System.Web.UI.WebControls.Button YesButton;
		protected System.Web.UI.WebControls.Button NoButton;
		protected System.Web.UI.WebControls.Panel HoursPanel;
		protected System.Web.UI.WebControls.Label OrLabel;
		protected System.Web.UI.WebControls.TextBox txtBox;
		protected System.Web.UI.HtmlControls.HtmlInputHidden requestSubmitted;
		protected System.Web.UI.WebControls.CustomValidator CustomValidator1;
		string STATIONID=VtkUserPageHeader.GetURLParameterString();

		/* EXPECTED INPUT:
		   Context.Items["USERID"]: optional; should be present if index.aspx was bypassed(not displayed to user)
		   Context.Items["CombinationCodeName"]: Name of combo code
		   Context.Items["OrganizationId"]: Org ID for the combo code
		   Context.Items["ScheduleId"]: Schedule ID for the combo code
		   Context.Items["BenefitingServiceId"]: Benefiting Service ID for the combo code
		*/
		public Timecard()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			OnLoadEvent += "labelSet();";
			myBody.Attributes.Add("onLoad","labelSet();");
			// get the userId, write auth cookie if necessary (if index.aspx transferred straight here without
			// having a chance to write the auth cookie itself)
			int userId = 0;
			if (Context.Items["USERID"]!=null) 
			{
				userId = (int) Context.Items["USERID"];
				Context.Items.Remove("USERID");
				FormsAuthentication.SetAuthCookie(userId.ToString(), false);

			} 
			else 
			{
				userId=Convert.ToInt32(Page.User.Identity.Name);
			}

			if (!IsPostBack) 
			{
				string confirmString;

				try 
				{
					//Sachy - 07/30/2003 Code change to fix Multiple submits.
					requestSubmitted.Value = "false";
					txtBox.Width = 0;

					VhaVtkUserPageHeader1.VerifyStation();
					string language=VhaVtkUserPageHeader1.CurrentLanguage;
					Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
					Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
				} 
				catch (Exception err)
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				}

				try 
				{
					LanguageResourcesLoad(out confirmString);
					//Page.RegisterOnSubmitStatement("HoursButton", "if (document.Timecard.HourList.selectedIndex>8) {return confirm('" + confirmString + "')}");
					HeadingLabel.Text = Context.Items["CombinationCodeName"].ToString();

					ViewState["OrganizationId"] = (int) Context.Items["OrganizationId"]; 
					ViewState["ScheduleId"] = (int) Context.Items["ScheduleId"];
					ViewState["BenefitingServiceId"] = (int) Context.Items["BenefitingServiceId"];

					Vha.Vtk.TimeKeeping.VolunteerHours timeCard = VolunteerHours.GetVolunteerHoursInstance(
						userId, VhaVtkUserPageHeader1.CurrentStationId,
						(int) Context.Items["OrganizationId"],
						(int) Context.Items["ScheduleId"],
						(int) Context.Items["BenefitingServiceId"],
						DateTime.Now.Date,
						VtkUtility.GetAppCon() );

					HoursButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
					if (timeCard.ID>0) 
					{
						//record already exists, set hourlist to current value
						VtkUtility.SetSelectedSingle(HourList.Items, timeCard.HoursWorked.ToString());
						//prompt user if they want to edit
						SetFields(true) ;
						YesButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
						NoButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");

					}
					else
					{
						myBody.Attributes.Add("onLoad", OnLoadEvent += "document.Timecard.HourList.focus();");
					}
					timeCard.Dispose();
				} 
				catch (Exception err) 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				}
			} 
			else 
			{
				string language=VhaVtkUserPageHeader1.CurrentLanguage;
				Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
				Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
			}
			try
			{
				//get the timeout value from web.config, it in in Path
				AppConfiguration VssConfig = new AppConfiguration(Server.MapPath("") + @"\web.config") ;
				VssConfig.Load() ;
				XmlNode ApplicationNode = VssConfig.GetAppConfigData("VssConfiguration", string.Empty) ;
				//save the timeout value and the stationId on form so it can be retrieve in HTML code
				string timeOut = ApplicationNode.Attributes.GetNamedItem("TimeOut").Value;
				string stationId = VhaVtkUserPageHeader1.CurrentStationId.ToString();
				MetaRefresh.Text = "<meta http-equiv=\"refresh\" content=\"" + timeOut + "; url=ThankYou.aspx?StationId=" + stationId + "\">";
			} 
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
			}
		}

		private void SetFields(bool promptUser)
		{
			AlreadyLabel1.Visible = promptUser ;
			AlreadyLabel2.Visible = promptUser ;
			YesButton.Visible = promptUser ;
			NoButton.Visible = promptUser ;
			HoursPanel.Visible = !promptUser ;
		}

		private void LanguageResourcesLoad(out string confirmString) 
		{
			Assembly a = Assembly.Load("VtkUser");
			ResourceManager rm = new ResourceManager("VtkUser.strings", a);
			HeadingLabel.Text=rm.GetString("timecardHeader");
			EnterHoursLabel.Text=rm.GetString("timecardEnterHours");
			HoursButton.Text=rm.GetString("txtSubmit");
			confirmString=rm.GetString("timecardConfirm");
			//VhaVtkUserPageHeader1.InfoLanguage="es";
		}

		private void HoursButton_Click(object sender, System.EventArgs e)
		{
			try 
			{
				// VolunteerHours timeCard=new VolunteerHours((int) ViewState["timeCardId"], VtkUtility.GetAppCon());
				try 
				{
					Vha.Vtk.TimeKeeping.VolunteerHours timeCard = VolunteerHours.GetVolunteerHoursInstance(
						Convert.ToInt32(Page.User.Identity.Name), 
						VhaVtkUserPageHeader1.CurrentStationId, 
						(int) ViewState["OrganizationId"], 
						(int) ViewState["ScheduleId"],
						(int) ViewState["BenefitingServiceId"],
						DateTime.Now.Date, 
						VtkUtility.GetAppCon() );
					if (Convert.ToInt32(HourList.SelectedItem.Value)!=timeCard.HoursWorked) 
					{
						timeCard.HoursWorked=Convert.ToInt32(HourList.SelectedItem.Value);
						ReturnStatus rs = timeCard.Save();
						//TODO: what if ReturnStatus not "pass"?
						timeCard.Dispose();
					}
					// pass the time to the next page
					Context.Items.Add("Time",TimeLabel.Value);
					Context.Items.Add("Hours",Convert.ToInt32(HourList.SelectedItem.Value));
					VhaVtkUserPageHeader1.ServerTransfer("MealTicket.aspx");
				} 
				catch (Exception err) 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				}

			} 
			catch (Exception err) 
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
			}
		}

		private void PageHeader_Click(object sender, System.EventArgs e)
		{

		}

		private void YesButton_Click(object sender, System.EventArgs e)
		{
			SetFields(false) ;
			myBody.Attributes.Add("onLoad","document.Timecard.HourList.focus();");

			//Sachy - 07/30/2003 Code change to fix Multiple submits.
			requestSubmitted.Value = "false";
			txtBox.Text = "false";
		}

		private void NoButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Thankyou.aspx?"+STATIONID+"="+Request.Params[STATIONID]);
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.VhaVtkUserPageHeader1.Click += new System.EventHandler(this.PageHeader_Click);
			this.HoursButton.Click += new System.EventHandler(this.HoursButton_Click);
			this.YesButton.Click += new System.EventHandler(this.YesButton_Click);
			this.NoButton.Click += new System.EventHandler(this.NoButton_Click);
			this.ID = "myForm";
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
