namespace VtkUser.Utility
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Web;
    using System.Web.SessionState;
    using System.Web.UI;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;

	using System.Configuration;
	using System.Security.Principal;
	using System.Diagnostics;

	using Vha.Vtk;
	using Vha.Vtk.TimeKeeping;
	using Vha.Vtk.Kernel.Common;
	using Vha.Vtk.Kernel.Data.SystemTables;

	//temporary
	using System.Web.Util;

    /// <summary>
    ///    Summary description for VtkUtility.
    /// </summary>

    public class VtkUtility
    {
		public static void SetSelectedSingle(System.Web.UI.WebControls.ListItemCollection myList, string myValue)		
		{
			for (int i=0;i<myList.Count;i++)
			{
				if (myList[i].Value==myValue) 
				{
					myList[i].Selected=true;
					//break;
				} 
				else 
				{
					myList[i].Selected=false;
				}
			}
		}

		public static bool CheckValue(System.Web.UI.WebControls.ListItemCollection myList, string myValue)
		{
			//return true if value is in list, false if not in list
			bool check = false ;
			for (int i=0;i<myList.Count;i++)
			{
				if (myList[i].Value == myValue)
				{
					check = true ;
					break ;
				}
			}
			return check ;
		}

		public static int FindIndex(System.Web.UI.WebControls.ListItemCollection myList, string myValue)
		{
			int i,j=0 ;
			//return index if value is in list, 0 if not in list
			for (i=0;i<myList.Count;i++)
			{
				if (myList[i].Value == myValue)
				{
					j = i ;
					break ;
				}
			}
			return j ;			
		}

		public static void PageCacheDisable(System.Web.HttpResponse response)
		{
			//response.Cache.AppendCacheExtension("private");
			response.Cache.SetCacheability(System.Web.HttpCacheability.NoCache);
			//response.Cache.SetNoStore();
			//response.Cache.SetNoServerCaching();
			//response.Cache.SetExpires(DateTime.Now);
			//response.AppendHeader("pragma","no-cache");
			//response.AppendHeader("cache-control","private");
		}

		public static ApplicationConnection GetAppCon()
		{
			//ApplicationConnection appCon = new ApplicationConnection(
				//(String)ConfigurationSettings.AppSettings["VhaConnectionString"]);
           // return appCon;


			ApplicationConnection appCon = new ApplicationConnection(
				ApplicationConnection.GetConnectionString());
			return appCon;
		}

		public static void PopulateDivisionList(Page callPage, ListItemCollection items, Label errorMessageLabel) 
		{
			internalPopulateDivisionList(callPage,items,errorMessageLabel);
		}
		
		public static void PopulateDivisionList(Page callPage, ListItemCollection items, Label errorMessageLabel, int divisionIdToSelect)
		{
			string divId=divisionIdToSelect.ToString();
			internalPopulateDivisionList(callPage,items,errorMessageLabel);
			for (int i=0;i<items.Count;i++)
			{
				if (items[i].Value==divId) 
				{
					items[i].Selected=true;
					break;
				}
			}
		}

		private static void internalPopulateDivisionList(Page callPage, ListItemCollection items, Label ErrorMessageLabel)
		{
			try 
			{
				// Populate Division drop-down list
				DataSet ds = Vha.Vtk.Kernel.Data.SystemTables.UserRole.GetUserRoleAtSites(callPage.User.Identity.Name, 
					VtkUtility.GetAppCon()) ;
				DataTable dt = ds.Tables["UserRolesAtSites"] ;
				DataView dv = new DataView(dt);
				dv.Sort="InstitutionName";
				dv.ApplyDefaultSort=true;
				string previousInstitutionName="";

				// filter out duplicate institutions returned for multiple site roles per institution
				for (int i=0;i<dv.Count;i++)
				{
					if (dv[i].Row["InstitutionName"].ToString()!=previousInstitutionName) 
					{
						ListItem li = new ListItem(dv[i].Row["InstitutionName"].ToString() +
							" (" + dv[i].Row["InstitutionNumber"]+")",
							dv[i].Row["InstitutionId"].ToString());
						items.Add(li);
						previousInstitutionName=dv[i].Row["InstitutionName"].ToString();
					}
				}
				dv.Dispose();
				dt.Dispose(); 
				ds.Dispose();
			} catch (Exception e)
			{
				ErrorMessageLabel.Text = "! There was an error retrieving Institutions: "
					+ e.ToString();
			}
		}

		public static void ErrMsgAdd (Label ErrorMessage, string NewErrMsg)
		{
			// Call this one to assemble an error message for display, but not to log it.
			//
			// appends NewErrMsg to ErrorMessage.Text
			//  if empty, adds a "! " first
			//  if not empty, removes closing period, if any, replaces with "; "
			//  adds a period at the end.

			VtkUtility.ErrMsgAddInternal(ErrorMessage, NewErrMsg);
		}

		public static void ErrMsgAdd (Label ErrorMessage, string NewErrMsg, string ModuleName)
		{
			// Call this one to assemble an error message for display, and also to log it.
			//
			// appends NewErrMsg to ErrorMessage.Text
			//  if empty, adds a "! " first
			//  if not empty, removes closing period, if any, replaces with "; "
			//  adds a period at the end.
			// ALSO: log the error in the Windows error log (w/module to log the page)

			VtkUtility.ErrMsgAddInternal(ErrorMessage, NewErrMsg);
			VtkUtility.ErrMsgWrtInternal(NewErrMsg, ModuleName);
		}

		public static void ErrMsgAdd (string NewErrMsg, string ModuleName)
		{
			// Call this one to log an error message, but not do anything as far as display.
			//
			// log the error in the Windows error log (w/module to log the page)

			VtkUtility.ErrMsgWrtInternal(NewErrMsg, ModuleName);
		}

		private static void ErrMsgWrtInternal (string NewErrMsg, string ModuleName) 
		{
			const string machine = ".";
			const string evtLogName = "Vha";
			const string source = "Voluntary TimeKeeping";

			if(!System.Diagnostics.EventLog.SourceExists(source))
			{
				System.Diagnostics.EventLog.CreateEventSource(source, evtLogName);
			}

			System.Diagnostics.EventLog evtLog = new System.Diagnostics.EventLog(evtLogName, machine, source);
			evtLog.WriteEntry(ModuleName+": "+NewErrMsg, EventLogEntryType.Error);
		}

		private static void ErrMsgAddInternal (Label ErrorMessage, string NewErrMsg)
		{
			// appends NewErrMsg to ErrorMessage.Text
			//  if empty, adds a "! " first
			//  if not empty, removes closing period, if any, replaces with "; "
			//  adds a period at the end.

			if (ErrorMessage.Text!=String.Empty)
			{
				ErrorMessage.Text=ErrorMessage.Text.Trim();
				// if existing error string ends with "!" or ".", truncate final character
				if ((ErrorMessage.Text.Substring((ErrorMessage.Text.Length-1),1)!=".") ||
					(ErrorMessage.Text.Substring((ErrorMessage.Text.Length-1),1)!="!"))
				{
					ErrorMessage.Text = ErrorMessage.Text.Substring(0,(ErrorMessage.Text.Length-1));
				}
				ErrorMessage.Text+="; ";
			} else 
			{
				ErrorMessage.Text="! ";
			}

			// Need to make sure NewErrMsg doesn't contain a web page, which it does if web service failure occurs
			// if so, need to strip out.

			int pos = NewErrMsg.ToUpper().IndexOf("<!DOCTYPE");
			if (pos>0)
			{
				NewErrMsg = NewErrMsg.Substring(0,pos)+ "(see Error Log for more detailed information)";
			} else 
			{
				pos = NewErrMsg.ToUpper().IndexOf("<HTML");
				if (pos>0)
				{
					NewErrMsg = NewErrMsg.Substring(0,pos)+ "(see Error Log for more detailed information)";
				} 
			}
			ErrorMessage.Text += NewErrMsg;
			// add a period if last character is not "!" or "."
			if ((ErrorMessage.Text.Substring((ErrorMessage.Text.Length-1),1)!=".") &&
				(ErrorMessage.Text.Substring((ErrorMessage.Text.Length-1),1)!="!"))
			{
				ErrorMessage.Text += ".";
			}
		}

		public static string MonthToString(int month) 
		{
			string returnValue="";
			switch (month)
			{
				case 1:
					returnValue="JAN";
					break;
				case 2:
					returnValue="FEB";
					break;
				case 3:
					returnValue="MAR";
					break;
				case 4:
					returnValue="APR";
					break;
				case 5:
					returnValue="MAY";
					break;
				case 6:
					returnValue="JUN";
					break;
				case 7:
					returnValue="JUL";
					break;
				case 8:
					returnValue="AUG";
					break;
				case 9:
					returnValue="SEP";
					break;
				case 10:
					returnValue="OCT";
					break;
				case 11:
					returnValue="NOV";
					break;
				case 12:
					returnValue="DEC";
					break;
				default:
					returnValue="UNKNOWN";
					break;
			}
			return returnValue;
		}

		public static string GetDateRangeHeader(DateTime beginDate, DateTime endDate) 
		{
			return "From "+VtkUtility.MonthToString(beginDate.Month) + " " +
				beginDate.Day.ToString()+", "+beginDate.Year.ToString() + " to " +
				VtkUtility.MonthToString(endDate.Month) + " " +
				endDate.Day.ToString() + ", "+endDate.Year.ToString();
		}

	// end of VtkUtility class
	}
}
