using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Drawing;
using System.Threading;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;
using System.Resources;
using System.Globalization;
using System.Text;
using System.Reflection;

using Vha.Vtk.Kernel.Data.SystemTables;
using Vha.Vtk.Common;
using Vha.Vtk.TimeKeeping;
using Vha.Vtk.WebControlLibrary;
using Vha.Vss.Utility;
using VtkUser.Utility;

namespace VtkUser
{
	/// <summary>
	/// Summary description for login.
	/// </summary>
	public class login : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox Username;
		protected System.Web.UI.WebControls.Label ErrorMessage;
		protected System.Web.UI.WebControls.Button LoginButton;
		protected System.Web.UI.WebControls.Panel LoginPanel;
		protected System.Web.UI.WebControls.DropDownList DivisionList;
		protected System.Web.UI.WebControls.Button DivisionButton;
		protected System.Web.UI.WebControls.Panel DivisionPanel;
		protected System.Web.UI.WebControls.Label HeadingLabel;
		protected System.Web.UI.WebControls.Label IdentifyingCodeLabel;
		protected System.Web.UI.WebControls.LinkButton LanguageButton;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label MultipleMatchLabel;
		protected System.Web.UI.WebControls.Button MatchCancelButton;
		protected System.Web.UI.WebControls.Panel ConfirmPanel;
		protected System.Web.UI.WebControls.Label ConfirmMessage;
		protected System.Web.UI.WebControls.HyperLink ConfirmUrl;
		protected System.Web.UI.WebControls.Panel MultipleMatchPanel;
		protected System.Web.UI.WebControls.CheckBox RememberLanguage;

		string STATIONID="StationId";
		string STATIONNUMBER = "StationNumber";

		protected System.Web.UI.HtmlControls.HtmlForm myForm;
		protected System.Web.UI.HtmlControls.HtmlGenericControl myBody;

		const string CURRENTLANGUAGECULTURE="CurrentLanguage";
		const string DEFAULTLANGUAGECULTURE="DefaultLanguageCulture";
		const string ALTERNATELANGUAGECULTURE="AlternateLanguageCulture";
		const string REMEMBERLANGUAGE="RememberLanguage";

		const string INFOVOLFULLNAMEFORREPORTS="VhaPageHeaderVolFullNameForReports";
		const string INFOSTATIONDISPLAYNAME="VhaPageHeaderStationDisplayName";
		const string INFOSTATIONID="VhaPageHeaderStationDisplayId";
		protected System.Web.UI.WebControls.TextBox IntroductoryText;
		protected System.Web.UI.WebControls.Label StationNameLabel;
		protected System.Web.UI.WebControls.CustomValidator CustomValidator1;
		protected System.Web.UI.WebControls.TextBox txtBox;
		protected System.Web.UI.HtmlControls.HtmlInputHidden requestSubmitted;
		protected System.Web.UI.WebControls.HyperLink SurveyLink;
		const string INFOLANGUAGE="VhaPageHeaderLanguage";

		// What is kept in ViewState in the various modes of this page
		// MODE: Division Selection
		//       (nothing)
		// MODE: Logon Selection
		//       ViewState[STATIONID]            : id of selected station
		//       ViewState[DEFAULTLANGUAGECULTURE]    : default language of selected station
		//       ViewState[ALTERNATELANGUAGECULTURE]  : alternate language of selected station
		//       ViewState[CURRENTLANGUAGECULTURE]    : only defined if the user changed the page language
		// MODE: Multiple IdentifyingCode Matches
		//       ViewState[STATIONID]            : id of selected station
		//       ViewState[DEFAULTLANGUAGECULTURE]    : default language of selected station
		//       ViewState[ALTERNATELANGUAGECULTURE]  : alternate language of selected station
		//       ViewState[CURRENTLANGUAGECULTURE]    : only defined if the user changed the page language
		//       ViewState[REMEMBERLANGUAGE]          : if they wanted to remember the language

		// Language behavior:
		//  User Has  User switches  Language to use  Language to use
		//  Default?      in logon?   for login page  for subsequent pages
		//  --------  -------------  ---------------  --------------------
		//        No             No     Site Default  Site Default
		//       Yes             No     Site Default  User Default
		//        No            Yes    User's choice  User's choice
		//       Yes            Yes    User's choice  User's choice

		public login()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Page.User.Identity.Name != "") 
			{
				FormsAuthentication.SignOut();
			}

			//Sachy - 07/30/2003 Code change to fix Multiple submits.
			requestSubmitted.Value = "false";
			txtBox.Width = 0;

			if ((ViewState[STATIONID] != null && (Request.Params[STATIONID] == ViewState[STATIONID].ToString()))
				||(ViewState[STATIONNUMBER] != null && (Request.Params[STATIONNUMBER] == ViewState[STATIONNUMBER].ToString())))
			{
				//Station is already verified, and it matches the STATIONID parameter
				if (LoginPanel.Visible && (Username.Text.Length > 0)) 
				{
					// this catches them pressing ENTER rather than clicking submit button
					// the only problem is if they enter text for their identifying code -- in that case,
					//   if they then click the "switch language" button, this ignores that and tries to
					//   log them in with whatever identifying code they entered. This is a trade-off -- do we
					//   gain more by logging them on when they press Enter? Possibly yes.
					// For more information see http://ppewww.ph.gla.ac.uk/~flavell/www/formquestion.html.
					//  "If the "focus" is on the submit button (e.g moved there with TAB) at the time that 
					//   Enter is pressed, then the submit button's name/value pair gets sent, and this seems 
					//   entirely reasonable. What's in question is what ought to happen when the focus is 
					//   somewhere else. "
					LoginButton_Click(sender, e);
				} 
				else 
				{
					EnableLogonPanel();
				}
			}
			else if (Request.Params[STATIONID] == null && Request.Params[STATIONNUMBER] == null) 
			{
				// coming in without a station specified in parameters
				EnableStationList();
			} 
			else 
			{
				// station in parameters, not viewstate (or doesn't match ViewState). 
				// first clear all current station info stored in the page
				ClearStationIfPresent();
				if (!CheckStation()) 
				{
					// if the station ID in the URL querystring is bogus, redirect to login page
					//TODO: include err in parameter? (get from contents of ErrorMessage)
					Response.Redirect("login.aspx");
				} 
				else 
				{
					// if the station ID is good, switch to "logon" mode
					EnableLogonPanel();
				}
			}
		}

		private void LanguageResourcesLoad() 
		{
			// get the various display strings for the page based on the current thread's culture setting
			Assembly a = Assembly.Load("VtkUser");
			ResourceManager rm = new ResourceManager("VtkUser.strings", a);

			HeadingLabel.Text=rm.GetString("loginHeader");
			ConfirmMessage.Text=rm.GetString("loginConfirmMessage");
			LanguageButton.Text=rm.GetString("loginLanguageButton");
			IdentifyingCodeLabel.Text=rm.GetString("loginIdentifyingCodeLabel");
			LoginButton.Text=rm.GetString("txtLogin");
			MultipleMatchLabel.Text=rm.GetString("loginMultipleMatchLabel");
			MatchCancelButton.Text=rm.GetString("txtCancel");
			RememberLanguage.Text=rm.GetString("loginRememberLanguage");
			((ButtonColumn)DataGrid1.Columns[2]).Text=rm.GetString("txtSelect");
		}
		private bool CheckStation() 
		{
			// Set the current station to the station in the URL "StationId" querystring,
			// if that station exists in the database -- and puts various station information into ViewState
			Language lang;
			try 
			{
				int _StationId = 0;
				if(Request.Params[STATIONNUMBER] != null)
				{
					_StationId = Institution.GetStationId((string)Request.Params[STATIONNUMBER].ToString());
					ViewState[STATIONNUMBER]=Request.Params[STATIONNUMBER];
					ViewState[STATIONID]=_StationId;
				}
				else if(Request.Params[STATIONID] != null)
				{
					_StationId = Convert.ToInt32(Request.Params[STATIONID]);
					ViewState[STATIONID]=_StationId;
				}

				StationParameters sp = new StationParameters(_StationId, VtkUtility.GetAppCon());
				if (sp.IntroductoryText != string.Empty)
				{
					IntroductoryText.Text = sp.IntroductoryText;
					IntroductoryText.Visible = true ;
				}
				else
				{ IntroductoryText.Visible = false ;}

				//get station name from VtkInstitution table
				Institution insthdl = new Institution(_StationId, VtkUtility.GetAppCon());
				StationNameLabel.Text = insthdl.NameOfInstitution ;
				StationNameLabel.Visible = true ;
				insthdl.Dispose() ;

				try 
				{
					//setup the default lange
					lang = new Language(sp.DefaultLanguageId,VtkUtility.GetAppCon());
					ViewState[DEFAULTLANGUAGECULTURE]=lang.Culture;
					//check if they want an alternate language
					if (sp.IsRequireAlternateLanguage)
					{
						lang.Dispose();
						lang = new Language(sp.AlternateLanguageId,VtkUtility.GetAppCon());
						ViewState[ALTERNATELANGUAGECULTURE]=lang.Culture;
						lang.Dispose();
					}
					else
					{
						//set alternate to english
						ViewState[ALTERNATELANGUAGECULTURE]=lang.Culture;
						RememberLanguage.Visible = false ;
						LanguageButton.Visible = false ;
						lang.Dispose();
					}
				} 
				catch
				{
					VtkUtility.ErrMsgAdd(ErrorMessage,"Could not access language. Edit Site Parameters for this station and make sure there is a Default Language!");
					// default to English
					ViewState[DEFAULTLANGUAGECULTURE]="en-US";
					//ViewState[ALTERNATELANGUAGECULTURE]="es";
					ViewState[ALTERNATELANGUAGECULTURE]="en-US";
				} 
				finally 
				{
					sp.Dispose();
				}
			} 
			catch (Exception err)
			{
				VtkUtility.ErrMsgAdd(ErrorMessage, err.Message);
				return false;
			}
			return true;
		}

		private void ClearStationIfPresent()
		{
			// remove all station settings from ViewState, and clear station Intro text
			if (ViewState[STATIONID]!=null) 
			{
				// not null, but doesn't match request param
				ViewState.Remove(STATIONID);
				ViewState.Remove(DEFAULTLANGUAGECULTURE);
				ViewState.Remove(ALTERNATELANGUAGECULTURE);
				ViewState.Remove(CURRENTLANGUAGECULTURE);
				IntroductoryText.Text="";
				IntroductoryText.Visible = false ;
			}
		}

		private void EnableLogonPanel()
		{
			// switch page to "logon" mode
			myBody.Attributes.Add("onLoad","document.myForm.Username.focus();");
			LoginButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
			string language=(string) ViewState[DEFAULTLANGUAGECULTURE];
			if (!IsPostBack) 
			{
				// ViewState[CURRENTLANGUAGECULTURE]=language;
				Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
				Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
				LanguageResourcesLoad();
			} 
			else 
			{
				// reset "language" to chosen language, if user chose one
				if (ViewState[CURRENTLANGUAGECULTURE]!=null)
				{
					language=(string) ViewState[CURRENTLANGUAGECULTURE];
				}
				Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(language);
				Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
				LanguageResourcesLoad();
			}

			/*  This was only used during testing
			if (Request.Params["confirm"]!=null) 
			{
				string url=Request.Url.Scheme+"://"+Request.Url.Host+Request.ApplicationPath+"/login.aspx?"+STATIONID+"="+ViewState[STATIONID];
				ConfirmUrl.Text=url;
				ConfirmUrl.NavigateUrl=url;
				ConfirmPanel.Visible=true;
			}
			*/
			DivisionPanel.Visible=false;
			MultipleMatchPanel.Visible=false;
			LoginPanel.Visible=true;
		}

		private void EnableMatchPanel()
		{
			// switch page to "several users matched the Identifing Code" mode
			DivisionPanel.Visible=false;
			MultipleMatchPanel.Visible=true;
			LoginPanel.Visible=false;
			// remove the javascript that focuses on the LoginPanel textbox
			myBody.Attributes.Remove("onLoad");
		}

		private void EnableStationList() 
		{
			DivisionButton.Attributes.Add("OnClick", "this.style.backgroundColor='red';this.style.color='black'");
			// switch page to "pick Station" mode
			DivisionPanel.Visible=true;
			MultipleMatchPanel.Visible=false;
			LoginPanel.Visible=false;
			StationNameLabel.Visible = false ;
			// remove the javascript that focuses on the LoginPanel textbox
			myBody.Attributes.Remove("onLoad");
			if (DivisionList.Items.Count<1)
			{
				try 
				{
					DivisionList.DataSource=Institution.GetQuickList();
					DivisionList.DataValueField="Id";
					DivisionList.DataTextField="Name";
					DivisionList.DataMember="InstitutionList";
					DivisionList.DataBind();
				} 
				catch (Exception err) 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
				}
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.LoginButton.Click += new System.EventHandler(this.LoginButton_Click);
			this.LanguageButton.Click += new System.EventHandler(this.LanguageButton_Click);
			this.DivisionButton.Click += new System.EventHandler(this.DivisionButton_Click);
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.MatchUser_Select);
			this.MatchCancelButton.Click += new System.EventHandler(this.MatchCancelButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LoginButton_Click(object sender, System.EventArgs e)
		{
			
			try 
			{
				string codeText = Username.Text ;
				//DataSet ds ;
				NameObjectCollection volList = new NameObjectCollection();
				NameObjectCollection volRec = new NameObjectCollection();
				int volCount = 0;
				int userId=0;
				//length is 5, then it is a code, else it is a ssn
				if (codeText.Length == 5)
				{
					//Page.Trace.Warn("Pre GetVolunteerListByIdentifierCode");
					volList = Volunteer.GetVolunteerDRByIdentifierCode(codeText, (int) ViewState[STATIONID], false, false);
					
					volCount = volList.Count;
					if (volList.Count > 0)
					{
						volRec = (NameObjectCollection)volList.Get(0);
						if (volRec.Count > 0)
						{
							userId = (Int32)volRec.Get("Column1");
						}
					}
				}
				else
				{ 
					//ds = Volunteer.GetVolunteerListBySSN(codeText, (int) ViewState[STATIONID]);
					volList = Volunteer.GetVolunteerDRBySSN(codeText, (int) ViewState[STATIONID], false);
					
					volCount = volList.Count;
					if (volList.Count > 0)
					{
						volRec = (NameObjectCollection)volList.Get(0);
						if (volRec.Count > 0)
						{
							userId = (Int32)volRec.Get("Column1");
						}
					}
				}
				volList.Dispose();
				volRec.Dispose();

				if (volCount==0) 
				{
					//Page.Trace.Warn("VolunteerList == 0");
					Assembly a = Assembly.Load("VtkUser");
					ResourceManager rm = new ResourceManager("VtkUser.strings", a);
					VtkUtility.ErrMsgAdd(ErrorMessage,rm.GetString("loginErrorCodeMatch"));
					//TODO: auditing if too many fails?
				} 
				else if (volCount==1)
				{
					//Page.Trace.Warn("VolunteerList == 1");
					//int userId=(int)ds.Tables["VolunteerList"].Rows[0]["Id"];
					UserAuthenticate(userId);
				} 
				else 
				{
					volList = Volunteer.GetVolunteerDRByIdentifierCode(codeText, (int) ViewState[STATIONID], false, true);

					DataTable dtVol = new DataTable("VolunteerList");
					DataSet ds = new DataSet("Volunteers");
					DataColumn dcVol;
					DataRow drVol;
					// Create new DataColumn, set DataType, ColumnName and add to DataTable.    
					dcVol= new DataColumn();
					dcVol.DataType = System.Type.GetType("System.Int32");
					dcVol.ColumnName = "Id";
					dtVol.Columns.Add(dcVol);

					dcVol= new DataColumn();
					dcVol.DataType  = typeof(string);
					dcVol.MaxLength = 120;
					dcVol.ColumnName = "DisplayName";
					dtVol.Columns.Add(dcVol);

					volCount = volList.Count;
					int intVol;
					for (intVol=1; intVol <= volCount; intVol++)
					{
						volRec = (NameObjectCollection)volList.Get(intVol-1);
						if (volRec.Count > 0)
						{
							drVol = dtVol.NewRow();
							drVol["Id"] = (Int32)volRec.Get("Column1");
							drVol["DisplayName"] = (string)volRec.Get("Column2");

							dtVol.Rows.Add(drVol);
						}
					}

					ds.Tables.Add(dtVol);
					//ds = Volunteer.GetVolunteerListByIdentifierCode(codeText, (int) ViewState[STATIONID], false);

					//Page.Trace.Warn("VolunteerList > 1");
					//Page.Trace.Warn("RememberLanguage: " + RememberLanguage.Checked.ToString());
					// multiple matches
					if (RememberLanguage.Checked) 
					{
						ViewState[REMEMBERLANGUAGE]=true;
					} 
					else 
					{
						ViewState[REMEMBERLANGUAGE]=false;
					}
					EnableMatchPanel();
					DataGrid1.DataSource=ds;
					DataGrid1.DataKeyField="Id";
					DataGrid1.DataMember="VolunteerList";
					
					//Page.Trace.Warn("Preped to BindData");
					DataGrid1.DataBind();
					ds.Dispose();
				}
				
				//Page.Trace.Warn("Disposing...");
				
			} 
			catch (Exception err) 
			{

				//VtkUtility.ErrMsgAdd(ErrorMessage,err.Message + " : " + err.GetBaseException().Message + "(1000." + lineNo + ")");			}
				VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);			
			}
	}

		private void UserAuthenticate(int userId) 
		{
			// set the language setting for the remainging pages in VTKUser, based on any stored database
			//   settings for this volunteer, plus any selection they made THIS time
			SetLanguage(userId);
			try 
			{
				// put items needed by the rest of the app into Context.Items
				PutVolunteerPropertiesIntoContext(userId);
				// Proceed into loging this user's hours
				Server.Transfer("index.aspx");
			} 
			catch (Exception err) 
			{
				ErrorMessage.Text=err.Message + " - (1005.0)";
				ErrorMessage.Visible=true;
			}
		}

		private void PutVolunteerPropertiesIntoContext(int userId) 
		{
			// Put userId, userName, Institution ID and Name, and selected language into Context.Items
			//   in preparation for completing logon and moving on to the rest of VTKUser.

			// userId
			Context.Items["USERID"]=userId;

			// userName
			Volunteer vol = new Volunteer(userId, VtkUtility.GetAppCon());
			Context.Items[INFOVOLFULLNAMEFORREPORTS]=vol.FullNameForReports;
			//vol.Dispose();

			// institution Id
			Context.Items[INFOSTATIONID]=(int) ViewState[STATIONID];

			//institution name
			Institution inst = new Institution((int) ViewState[STATIONID],VtkUtility.GetAppCon());
			if (inst.NameOfInstitution.Length!=0) 
			{
				Context.Items[INFOSTATIONDISPLAYNAME]=inst.NameOfInstitution;
			}
			inst.Dispose();

			//language
			if (ViewState[CURRENTLANGUAGECULTURE]!=null) 
			{
				// if they set the language during this session
				Context.Items[INFOLANGUAGE]=(string)ViewState[CURRENTLANGUAGECULTURE];
			}
			else 
			{ 
				// check if they've ever set a language preference. If so, set these pages to that preference
				//vol = new Volunteer(userId, VtkUtility.GetAppCon());
				if (vol.PreferredLanguageForLoginId>0) 
				{
					Vha.Vtk.Kernel.Data.SystemTables.Language storedLanguage = 
						new Vha.Vtk.Kernel.Data.SystemTables.Language(vol.PreferredLanguageForLoginId, VtkUtility.GetAppCon());
					Context.Items[INFOLANGUAGE]=storedLanguage.Culture;
					storedLanguage.Dispose();
				}
				else // set language to site default language
				{
					Context.Items[INFOLANGUAGE]= ViewState[DEFAULTLANGUAGECULTURE];
				}
				//vol.Dispose();
			}
			vol.Dispose();
		}

		private void SetLanguage(int userId) 
		{
			// This function has all the logic/business rules for determining what language selection
			//  to use for the other pages in the VTKUser app, once the user moves off of the logon page

			bool rememberLanguageMultipleMatch=false;
			if (ViewState[REMEMBERLANGUAGE]!=null) 
			{
				rememberLanguageMultipleMatch=(bool)ViewState[REMEMBERLANGUAGE];
			}

			//TODO: see if this works if multiple logins were matched
			if (RememberLanguage.Checked||rememberLanguageMultipleMatch) 
			{
				int currentLanguageId=0;
				try 
				{
					if (ViewState[CURRENTLANGUAGECULTURE]!=null) 
					{
						// if the user changed the language from the site default, get that here
						currentLanguageId=Vha.Vtk.Kernel.Data.SystemTables.Language.GetIdForCulture(
							(string) ViewState[CURRENTLANGUAGECULTURE]);
					} 
					else 
					{
						// get ID from current default language
						currentLanguageId=Vha.Vtk.Kernel.Data.SystemTables.Language.GetIdForCulture(
							(string) ViewState[DEFAULTLANGUAGECULTURE]);
					}

					Volunteer vol = new Volunteer(userId, VtkUtility.GetAppCon());
					if (vol.PreferredLanguageForLoginId!=currentLanguageId) 
					{
						vol.PreferredLanguageForLoginId = currentLanguageId;
						vol.Save();
					}
					vol.Dispose();
				} 
				catch (Exception err) 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage,err.Message);
				}
			}
		}

		private void DivisionButton_Click(object sender, System.EventArgs e)
		{
			//Response.Redirect("login.aspx?"+STATIONID+"="+DivisionList.SelectedItem.Value+"&confirm=true");
			Response.Redirect("login.aspx?"+STATIONID+"="+DivisionList.SelectedItem.Value) ;

			//Sachy - 07/30/2003 Code change to fix Multiple submits.
			requestSubmitted.Value = "false";
			txtBox.Text = "false";
		}

		private void LanguageButton_Click(object sender, System.EventArgs e)
		{
			// decide which language to switch to 
			if (ViewState[CURRENTLANGUAGECULTURE]==null) 
			{
				// hasn't switched language on this page yet, first time
				if (((string)ViewState[DEFAULTLANGUAGECULTURE])=="en-US") 
				{
					switchEspanol();
				} 
				else if (((string)ViewState[DEFAULTLANGUAGECULTURE])=="es") 
				{
					switchEnglish();
				} 
				else 
				{
					VtkUtility.ErrMsgAdd(ErrorMessage, "Current language setting unknown.");
				}
			} else if (ViewState[CURRENTLANGUAGECULTURE]!=null)
			{
				if (((string)ViewState[CURRENTLANGUAGECULTURE])=="en-US") 
				{
					switchEspanol();
				} 
				else if (((string)ViewState[CURRENTLANGUAGECULTURE])=="es") 
				{
					switchEnglish();
				}
			}
		}

		private void switchEspanol() 
		{
			Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("es");
			Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
			LanguageResourcesLoad();
			ViewState[CURRENTLANGUAGECULTURE]="es";
		}

		private void switchEnglish() 
		{
			Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("en-US");
			Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
			LanguageResourcesLoad();
			ViewState[CURRENTLANGUAGECULTURE]="en-US";
		}

		private void MatchCancelButton_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("login.aspx?"+STATIONID+"="+ViewState[STATIONID]);

			//Sachy - 07/30/2003 Code change to fix Multiple submits.
			requestSubmitted.Value = "false";
			txtBox.Text = "false";
		}

		private void MatchUser_Select(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			UserAuthenticate(Convert.ToInt32(e.Item.Cells[0].Text));
		}

	}
}

